import { faFileAlt } from "@fortawesome/free-solid-svg-icons/faFileAlt";
import { faLock } from "@fortawesome/free-solid-svg-icons/faLock";
import { h } from "@stencil/core";
import classNames from "classnames";
export class TransactionAccount {
    constructor() {
        this.showLockedAccounts = false;
    }
    render() {
        return (h("div", { key: '9822fb47ce1f3538329e7d70c968b9ee422d6db0', class: classNames(this.class, 'transaction-account'), "data-testid": this.dataTestId }, this.showLockedAccounts && this.account.isTokenLocked && h("mvx-fa-icon", { key: '027759e3b0069d5fe4f806e385512c799b3c67ff', icon: faLock, description: this.account.name }), this.account.isContract && h("mvx-fa-icon", { key: 'b27edc5335959f69013eb3260913f7c4366e7866', icon: faFileAlt, description: "Smart Contract" }), this.account.showLink ? (h("mvx-explorer-link", { link: this.account.link, "data-testid": `${this.scope}Link` }, h("mvx-transaction-account-name", { slot: "content", name: this.account.name, description: this.account.description, address: this.account.address }))) : (h("mvx-transaction-account-name", { name: this.account.name, description: this.account.description, address: this.account.address }))));
    }
    static get is() { return "mvx-transaction-account"; }
    static get originalStyleUrls() {
        return {
            "$": ["transaction-account.css"]
        };
    }
    static get styleUrls() {
        return {
            "$": ["transaction-account.css"]
        };
    }
    static get properties() {
        return {
            "account": {
                "type": "unknown",
                "attribute": "account",
                "mutable": false,
                "complexType": {
                    "original": "ITransactionAccount",
                    "resolved": "ITransactionAccount",
                    "references": {
                        "ITransactionAccount": {
                            "location": "import",
                            "path": "../../transactions-table.type",
                            "id": "src/components/controlled/transactions-table/transactions-table.type.ts::ITransactionAccount"
                        }
                    }
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false
            },
            "class": {
                "type": "string",
                "attribute": "class",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false,
                "reflect": false
            },
            "dataTestId": {
                "type": "string",
                "attribute": "data-test-id",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false,
                "reflect": false
            },
            "scope": {
                "type": "string",
                "attribute": "scope",
                "mutable": false,
                "complexType": {
                    "original": "'receiver' | 'sender'",
                    "resolved": "\"receiver\" | \"sender\"",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false,
                "reflect": false
            },
            "showLockedAccounts": {
                "type": "boolean",
                "attribute": "show-locked-accounts",
                "mutable": false,
                "complexType": {
                    "original": "boolean",
                    "resolved": "boolean",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false,
                "reflect": false,
                "defaultValue": "false"
            }
        };
    }
}
//# sourceMappingURL=transaction-account.js.map
