import { h } from "@stencil/core";
import classNames from "classnames";
import { DataTestIdsEnum } from "../../../../../constants/dataTestIds.enum";
export class TransactionMethod {
    render() {
        return (h("span", { key: 'bcdad8da2a7ba0c29eeb1b6af32c20ca00c9acad', class: classNames('badge badge-secondary badge-pill font-weight-light transaction-method', this.class), "data-testid": DataTestIdsEnum.method, title: this.actionDescription }, h("div", { key: '9b4af0d970fad601d038936f70abc31d4902646c', class: "badge badge-secondary badge-pill" }, h("div", { key: 'df280a23a202b0be246f31d594db84f3a3dbe698', class: "text-truncate text-capitalize text-white" }, this.method))));
    }
    static get is() { return "mvx-transaction-method"; }
    static get originalStyleUrls() {
        return {
            "$": ["transaction-method.css"]
        };
    }
    static get styleUrls() {
        return {
            "$": ["transaction-method.css"]
        };
    }
    static get properties() {
        return {
            "class": {
                "type": "string",
                "attribute": "class",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false,
                "reflect": false
            },
            "actionDescription": {
                "type": "string",
                "attribute": "action-description",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false,
                "reflect": false
            },
            "method": {
                "type": "string",
                "attribute": "method",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false,
                "reflect": false
            }
        };
    }
}
//# sourceMappingURL=transaction-method.js.map
