import { h } from "@stencil/core";
import { DataTestIdsEnum } from "../../../../constants/dataTestIds.enum";
export class LedgerConfirm {
    render() {
        const ledgerConfirmationItems = [
            { label: this.confirmScreenData.confirmAddressText, value: this.confirmScreenData.selectedAddress, explorerLink: this.confirmScreenData.addressExplorerLink },
            { label: this.confirmScreenData.authText, value: this.confirmScreenData.data, highlighted: true },
        ];
        return (h("div", { key: 'bec347a601747adddb353120a8dacc9910d4b3b0', "data-testid": DataTestIdsEnum.ledgerConfirmAddress, class: "ledger-confirm" }, h("div", { key: '23dc8a9a2f6a468d313672afa599ae9fc717c548', class: "ledger-confirm-items" }, ledgerConfirmationItems.map(ledgerConfirmationItem => (h("div", { class: "ledger-confirm-item" }, h("div", { class: "ledger-confirm-item-label" }, ledgerConfirmationItem.label), h("div", { class: "ledger-confirm-item-value" }, h("div", { class: { 'ledger-confirm-item-value-text': true, 'highlighted': Boolean(ledgerConfirmationItem.highlighted) } }, ledgerConfirmationItem.value), h("div", { class: "ledger-confirm-item-value-actions" }, h("mvx-copy-button", { text: ledgerConfirmationItem.value, class: "ledger-confirm-item-value-copy", iconClass: "ledger-confirm-item-value-copy-icon" }), ledgerConfirmationItem.explorerLink && (h("mvx-explorer-link", { link: ledgerConfirmationItem.explorerLink, class: "ledger-confirm-item-value-explorer", iconClass: "ledger-confirm-item-value-explorer-icon" })))))))), h("div", { key: 'c190a641192c8f3b80fd1d9f5a0cf73f84ef28bc', class: "ledger-confirm-action" }, "Select ", h("strong", { key: '207102f7ed72f378625fef7693a77bdeb9031fec' }, "Approve"), " on your device to confirm."), h("div", { key: '3fd80eba34401a895f3728021d55515129ca936a', class: "ledger-confirm-footer" }, h("mvx-triangular-warning-icon", { key: '6d08316aa66fc7d1ea89fe229492c9f77a47a08a', class: "ledger-confirm-footer-icon" }), h("div", { key: '0bf61cad785fecea0718c128dd1d49a6e6719301', class: "ledger-confirm-footer-description" }, "If the address does not mach close this page and contact support."), h("a", { key: '3f3a5915dd22bfa429d9f90b80c5085775e78f3c', target: "_blank", rel: "noreferrer", href: "https://help.multiversx.com/en/", class: "ledger-confirm-footer-button" }, "Contact Support"))));
    }
    static get is() { return "mvx-ledger-confirm"; }
    static get encapsulation() { return "shadow"; }
    static get originalStyleUrls() {
        return {
            "$": ["ledger-confirm.scss"]
        };
    }
    static get styleUrls() {
        return {
            "$": ["ledger-confirm.css"]
        };
    }
    static get properties() {
        return {
            "confirmScreenData": {
                "type": "unknown",
                "attribute": "confirm-screen-data",
                "mutable": false,
                "complexType": {
                    "original": "IConfirmScreenData",
                    "resolved": "IConfirmScreenData",
                    "references": {
                        "IConfirmScreenData": {
                            "location": "import",
                            "path": "../ledger.types",
                            "id": "src/components/functional/ledger/ledger.types.ts::IConfirmScreenData"
                        }
                    }
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false
            }
        };
    }
}
//# sourceMappingURL=ledger-confirm.js.map
