import { h } from "@stencil/core";
import { ProviderTypeEnum } from "../../../../../types/provider.types";
export class UnlockProviderIntro {
    constructor() {
        this.provider = null;
    }
    render() {
        switch (this.provider) {
            case ProviderTypeEnum.ledger:
                return h("mvx-ledger-intro", { onConnect: this.access.emit });
            default:
                return null;
        }
    }
    static get is() { return "mvx-unlock-provider-intro"; }
    static get encapsulation() { return "shadow"; }
    static get originalStyleUrls() {
        return {
            "$": ["unlock-provider-intro.scss"]
        };
    }
    static get styleUrls() {
        return {
            "$": ["unlock-provider-intro.css"]
        };
    }
    static get properties() {
        return {
            "provider": {
                "type": "string",
                "attribute": "provider",
                "mutable": false,
                "complexType": {
                    "original": "ProviderTypeEnum | null",
                    "resolved": "ProviderTypeEnum.crossWindow | ProviderTypeEnum.extension | ProviderTypeEnum.ledger | ProviderTypeEnum.metamask | ProviderTypeEnum.passkey | ProviderTypeEnum.walletConnect | ProviderTypeEnum.xalias",
                    "references": {
                        "ProviderTypeEnum": {
                            "location": "import",
                            "path": "types/provider.types",
                            "id": "src/types/provider.types.ts::ProviderTypeEnum"
                        }
                    }
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false,
                "reflect": false,
                "defaultValue": "null"
            }
        };
    }
    static get events() {
        return [{
                "method": "access",
                "name": "access",
                "bubbles": true,
                "cancelable": true,
                "composed": true,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "complexType": {
                    "original": "any",
                    "resolved": "any",
                    "references": {}
                }
            }];
    }
}
//# sourceMappingURL=unlock-provider-intro.js.map
