import { h, p as proxyCustomElement, H, F as Fragment } from './p-C6Ye8jK5.js';
import { P as ProviderTypeEnum, a as ProviderLabelsEnum } from './p-BZSByugD.js';
import { d as defineCustomElement$9 } from './p-Bu_IiCIv.js';
import { d as defineCustomElement$8 } from './p-CKvefzkn.js';
import { d as defineCustomElement$7 } from './p-C7bvx-20.js';
import { d as defineCustomElement$6 } from './p-C_h1Ysew.js';
import { d as defineCustomElement$5 } from './p-2CFIVj0B.js';
import { d as defineCustomElement$4 } from './p-BVzpQtTK.js';
import { d as defineCustomElement$3 } from './p-odfGTZSl.js';
import { d as defineCustomElement$2 } from './p-BonMfSk1.js';
import { d as defineCustomElement$1 } from './p-BixrhZJO.js';

const providerButtonInfo = {
    [ProviderTypeEnum.extension]: {
        icon: h("mvx-extension-provider-icon", null),
        label: ProviderLabelsEnum.extension,
    },
    [ProviderTypeEnum.metamask]: {
        icon: h("mvx-metamask-provider-icon", null),
        label: ProviderLabelsEnum.metamask,
    },
    [ProviderTypeEnum.passkey]: {
        icon: h("mvx-passkey-provider-icon", null),
        label: ProviderLabelsEnum.passkey,
    },
    [ProviderTypeEnum.walletConnect]: {
        icon: h("mvx-multiversx-logo-icon", null),
        label: ProviderLabelsEnum.walletConnect,
    },
    [ProviderTypeEnum.ledger]: {
        icon: h("mvx-ledger-provider-icon", null),
        label: ProviderLabelsEnum.ledger,
    },
    [ProviderTypeEnum.crossWindow]: {
        icon: h("mvx-wallet-provider-icon", null),
        label: ProviderLabelsEnum.crossWindow,
    },
    [ProviderTypeEnum.xalias]: {
        icon: h("mvx-xalias-provider-icon", null),
        label: ProviderLabelsEnum.xalias,
    },
};
const UnlockProviderButton = /*@__PURE__*/ proxyCustomElement(class UnlockProviderButton extends H {
    constructor() {
        super();
        this.__registerHost();
        this.__attachShadow();
    }
    render() {
        const walletInfo = this.type ? providerButtonInfo[this.type] : null;
        if (!walletInfo) {
            return h(Fragment, null);
        }
        return h("mvx-unlock-button", { icon: walletInfo.icon, label: walletInfo.label, type: this.type, class: this.class });
    }
}, [1, "mvx-unlock-provider-button", {
        "type": [1],
        "providers": [16],
        "class": [1]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["mvx-unlock-provider-button", "mvx-arrow-up-right-icon", "mvx-extension-provider-icon", "mvx-ledger-provider-icon", "mvx-metamask-provider-icon", "mvx-multiversx-logo-icon", "mvx-passkey-provider-icon", "mvx-unlock-button", "mvx-wallet-provider-icon", "mvx-xalias-provider-icon"];
    components.forEach(tagName => { switch (tagName) {
        case "mvx-unlock-provider-button":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, UnlockProviderButton);
            }
            break;
        case "mvx-arrow-up-right-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$9();
            }
            break;
        case "mvx-extension-provider-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$8();
            }
            break;
        case "mvx-ledger-provider-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$7();
            }
            break;
        case "mvx-metamask-provider-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$6();
            }
            break;
        case "mvx-multiversx-logo-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$5();
            }
            break;
        case "mvx-passkey-provider-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$4();
            }
            break;
        case "mvx-unlock-button":
            if (!customElements.get(tagName)) {
                defineCustomElement$3();
            }
            break;
        case "mvx-wallet-provider-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$2();
            }
            break;
        case "mvx-xalias-provider-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$1();
            }
            break;
    } });
}

export { UnlockProviderButton as U, defineCustomElement as d };
//# sourceMappingURL=p-CbM_mmBj.js.map

//# sourceMappingURL=p-CbM_mmBj.js.map