import { r as registerInstance, h } from './index-DeR7QOsF.js';
import { g as getIsExtensionAvailable, a as getIsMetaMaskAvailable } from './getIsMetaMaskAvailable-CItYS8On.js';
import { P as ProviderTypeEnum } from './provider.types-BZSByugD.js';

const ArrowUpRightIcon = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
    }
    render() {
        return (h("svg", { key: "1f3e78a7a70d3ad35496117bccae6e6c2dca5e0f", xmlns: "http://www.w3.org/2000/svg", viewBox: "0 0 10 10", width: "10", height: "10", fill: "none" }, h("path", { key: "24d37793e481d5a6eee4d7d98b96a042fe897b11", d: "M8.9375 0.944824C9.15625 0.944824 9.375 1.16357 9.375 1.38232V7.50732C9.375 7.75342 9.15625 7.94482 8.9375 7.94482C8.69141 7.94482 8.5 7.75342 8.5 7.50732V2.44873L1.36328 9.58545C1.19922 9.74951 0.898438 9.74951 0.734375 9.58545C0.570312 9.42139 0.570312 9.12061 0.734375 8.95654L7.87109 1.81982H2.8125C2.56641 1.81982 2.375 1.62842 2.375 1.38232C2.375 1.16357 2.56641 0.944824 2.8125 0.944824H8.9375Z", fill: "#E5E5E5" })));
    }
};

ArrowUpRightIcon.style = '/*! tailwindcss v4.1.3 | MIT License | https://tailwindcss.com */@layer theme{:root,:host{--mvx-font-sans:ui-sans-serif,system-ui,sans-serif,"Apple Color Emoji","Segoe UI Emoji","Segoe UI Symbol","Noto Color Emoji";--mvx-font-mono:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,"Liberation Mono","Courier New",monospace;--mvx-default-font-family:var(--mvx-font-sans);--mvx-default-mono-font-family:var(--mvx-font-mono)}}@layer base{*,:after,:before,::backdrop{box-sizing:border-box;border:0 solid;margin:0;padding:0}::file-selector-button{box-sizing:border-box;border:0 solid;margin:0;padding:0}html,:host{-webkit-text-size-adjust:100%;tab-size:4;line-height:1.5;font-family:var(--mvx-default-font-family,ui-sans-serif,system-ui,sans-serif,"Apple Color Emoji","Segoe UI Emoji","Segoe UI Symbol","Noto Color Emoji");font-feature-settings:var(--mvx-default-font-feature-settings,normal);font-variation-settings:var(--mvx-default-font-variation-settings,normal);-webkit-tap-highlight-color:transparent}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;-webkit-text-decoration:inherit;-webkit-text-decoration:inherit;-webkit-text-decoration:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:var(--mvx-default-mono-font-family,ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,"Liberation Mono","Courier New",monospace);font-feature-settings:var(--mvx-default-mono-font-feature-settings,normal);font-variation-settings:var(--mvx-default-mono-font-variation-settings,normal);font-size:1em}small{font-size:80%}sub,sup{vertical-align:baseline;font-size:75%;line-height:0;position:relative}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}:-moz-focusring{outline:auto}progress{vertical-align:baseline}summary{display:list-item}ol,ul,menu{list-style:none}img,svg,video,canvas,audio,iframe,embed,object{vertical-align:middle;display:block}img,video{max-width:100%;height:auto}button,input,select,optgroup,textarea{font:inherit;font-feature-settings:inherit;font-variation-settings:inherit;letter-spacing:inherit;color:inherit;opacity:1;background-color:#0000;border-radius:0}::file-selector-button{font:inherit;font-feature-settings:inherit;font-variation-settings:inherit;letter-spacing:inherit;color:inherit;opacity:1;background-color:#0000;border-radius:0}:where(select:is([multiple],[size])) optgroup{font-weight:bolder}:where(select:is([multiple],[size])) optgroup option{padding-inline-start:20px}::file-selector-button{margin-inline-end:4px}::placeholder{opacity:1}@supports (not ((-webkit-appearance:-apple-pay-button))) or (contain-intrinsic-size:1px){::placeholder{color:currentColor}@supports (color:color-mix(in lab, red, red)){::placeholder{color:color-mix(in oklab,currentColor 50%,transparent)}}}textarea{resize:vertical}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-date-and-time-value{min-height:1lh;text-align:inherit}::-webkit-datetime-edit{display:inline-flex}::-webkit-datetime-edit-fields-wrapper{padding:0}::-webkit-datetime-edit{padding-block:0}::-webkit-datetime-edit-year-field{padding-block:0}::-webkit-datetime-edit-month-field{padding-block:0}::-webkit-datetime-edit-day-field{padding-block:0}::-webkit-datetime-edit-hour-field{padding-block:0}::-webkit-datetime-edit-minute-field{padding-block:0}::-webkit-datetime-edit-second-field{padding-block:0}::-webkit-datetime-edit-millisecond-field{padding-block:0}::-webkit-datetime-edit-meridiem-field{padding-block:0}:-moz-ui-invalid{box-shadow:none}button,input:where([type=button],[type=reset],[type=submit]){appearance:button}::file-selector-button{appearance:button}::-webkit-inner-spin-button{height:auto}::-webkit-outer-spin-button{height:auto}[hidden]:where(:not([hidden=until-found])){display:none!important}}@layer components,utilities; ';

const ExtensionProviderIcon = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
    }
    render() {
        return (h("svg", { key: "8340a72a105ef224d1bcc77811a413117b780e7f", xmlns: "http://www.w3.org/2000/svg", width: "46", height: "44", viewBox: "0 0 46 44", fill: "none" }, h("mask", { key: "c790174b20eeb47475ed0c5cfebcda6d1ba1ed4f", id: "mask0_8093_13961", maskUnits: "userSpaceOnUse", x: "0", y: "4", width: "40", height: "40" }, h("path", { key: "114bf11172ec4d34714a9b305e6a946b28958b80", "fill-rule": "evenodd", "clip-rule": "evenodd", d: "M40 16.4576C40 15.9828 40.0002 15.5079 39.9973 15.033C39.9949 14.6329 39.9903 14.233 39.9794 13.8331C39.9559 12.9616 39.9045 12.0826 39.7495 11.2208C39.5923 10.3466 39.3356 9.53299 38.9311 8.73867C38.5335 7.95795 38.014 7.24353 37.3942 6.62417C36.7745 6.0048 36.0599 5.48567 35.2789 5.08825C34.4838 4.68364 33.6693 4.42704 32.7941 4.2699C31.9322 4.11515 31.053 4.06383 30.1815 4.04029C29.7813 4.02947 29.3812 4.0249 28.9809 4.02243C28.5058 4.01951 28.0307 4.01976 27.5555 4.01976L22.0387 4H17.9125L12.4933 4.01976C12.0172 4.01976 11.5411 4.01951 11.0651 4.02243C10.664 4.0249 10.2631 4.02947 9.86221 4.04029C8.98867 4.06383 8.10746 4.11519 7.24354 4.27014C6.36719 4.42723 5.55146 4.68374 4.75526 5.08805C3.97259 5.48553 3.25643 6.0047 2.63547 6.62417C2.0146 7.24348 1.49416 7.95775 1.09577 8.73833C0.69014 9.53304 0.432958 10.3472 0.275386 11.2219C0.120242 12.0833 0.0688344 12.962 0.0451938 13.8331C0.0344172 14.233 0.0297571 14.633 0.0273299 15.033C0.0244173 15.5079 0 16.0979 0 16.5728L0.00014563 21.9169L0 26.0873L0.02466 31.545C0.02466 32.0205 0.0244658 32.4961 0.0273299 32.9716C0.0297571 33.3722 0.0344172 33.7727 0.0452424 34.1731C0.0688344 35.0457 0.120339 35.926 0.275629 36.7889C0.433152 37.6643 0.690286 38.4791 1.09557 39.2744C1.49402 40.0563 2.01455 40.7716 2.63547 41.3919C3.25638 42.0121 3.97235 42.5319 4.75487 42.9299C5.55156 43.335 6.36767 43.592 7.24456 43.7493C8.1081 43.9043 8.98901 43.9557 9.86221 43.9793C10.2631 43.9901 10.664 43.9947 11.0651 43.9971C11.5412 44 12.0172 43.9999 12.4933 43.9999L17.9615 44H22.0979L27.5555 43.9998C28.0307 43.9998 28.5058 44 28.9809 43.9971C29.3812 43.9947 29.7813 43.9901 30.1815 43.9793C31.0533 43.9557 31.9328 43.9042 32.7951 43.7491C33.6698 43.5918 34.4839 43.335 35.2786 42.9301C36.0597 42.5321 36.7745 42.0122 37.3942 41.3919C38.0139 40.7717 38.5333 40.0565 38.931 39.2748C39.3357 38.479 39.5924 37.6639 39.7497 36.7879C39.9046 35.9253 39.9559 35.0454 39.9795 34.1731C39.9903 33.7726 39.9949 33.3721 39.9973 32.9716C40.0002 32.4961 40 32.0205 40 31.545C40 31.545 39.9997 26.1837 39.9997 26.0873V21.9126C39.9997 21.8414 40 16.4576 40 16.4576Z", fill: "white" })), h("g", { key: "2d3d96a36dda943a54d55f91ef6f712cc134fdc0", mask: "url(#mask0_8093_13961)" }, h("path", { key: "36671ca73c496c57c326d8945a0a10503b642e32", "fill-rule": "evenodd", "clip-rule": "evenodd", d: "M40 16.4576C40 15.9828 40.0002 15.5079 39.9973 15.033C39.9949 14.6329 39.9903 14.233 39.9794 13.8331C39.9559 12.9616 39.9045 12.0826 39.7495 11.2208C39.5923 10.3466 39.3356 9.53299 38.9311 8.73867C38.5335 7.95795 38.014 7.24353 37.3942 6.62417C36.7745 6.0048 36.0599 5.48567 35.2789 5.08825C34.4838 4.68364 33.6693 4.42704 32.7941 4.2699C31.9322 4.11515 31.053 4.06383 30.1815 4.04029C29.7813 4.02947 29.3812 4.0249 28.9809 4.02243C28.5058 4.01951 28.0307 4.01976 27.5555 4.01976L22.0387 4H17.9125L12.4933 4.01976C12.0172 4.01976 11.5411 4.01951 11.0651 4.02243C10.664 4.0249 10.2631 4.02947 9.86221 4.04029C8.98867 4.06383 8.10746 4.11519 7.24354 4.27014C6.36719 4.42723 5.55146 4.68374 4.75526 5.08805C3.97259 5.48553 3.25643 6.0047 2.63547 6.62417C2.0146 7.24348 1.49416 7.95775 1.09577 8.73833C0.69014 9.53304 0.432958 10.3472 0.275386 11.2219C0.120242 12.0833 0.0688344 12.962 0.0451938 13.8331C0.0344172 14.233 0.0297571 14.633 0.0273299 15.033C0.0244173 15.5079 0 16.0979 0 16.5728L0.00014563 21.9169L0 26.0873L0.02466 31.545C0.02466 32.0205 0.0244658 32.4961 0.0273299 32.9716C0.0297571 33.3722 0.0344172 33.7727 0.0452424 34.1731C0.0688344 35.0457 0.120339 35.926 0.275629 36.7889C0.433152 37.6643 0.690286 38.4791 1.09557 39.2744C1.49402 40.0563 2.01455 40.7716 2.63547 41.3919C3.25638 42.0121 3.97235 42.5319 4.75487 42.9299C5.55156 43.335 6.36767 43.592 7.24456 43.7493C8.1081 43.9043 8.98901 43.9557 9.86221 43.9793C10.2631 43.9901 10.664 43.9947 11.0651 43.9971C11.5412 44 12.0172 43.9999 12.4933 43.9999L17.9615 44H22.0979L27.5555 43.9998C28.0307 43.9998 28.5058 44 28.9809 43.9971C29.3812 43.9947 29.7813 43.9901 30.1815 43.9793C31.0533 43.9557 31.9328 43.9042 32.7951 43.7491C33.6698 43.5918 34.4839 43.335 35.2786 42.9301C36.0597 42.5321 36.7745 42.0122 37.3942 41.3919C38.0139 40.7717 38.5333 40.0565 38.931 39.2748C39.3357 38.479 39.5924 37.6639 39.7497 36.7879C39.9046 35.9253 39.9559 35.0454 39.9795 34.1731C39.9903 33.7726 39.9949 33.3721 39.9973 32.9716C40.0002 32.4961 40 32.0205 40 31.545C40 31.545 39.9997 26.1837 39.9997 26.0873V21.9126C39.9997 21.8414 40 16.4576 40 16.4576Z", fill: "#143736" }), h("rect", { key: "a79af2260ff31c94e5318f00c2d9831d65ec8883", opacity: "0.4", x: "0.169903", y: "10.3349", width: "39.6602", height: "39.6602", rx: "8.76214", fill: "url(#paint0_linear_8093_13961)", stroke: "url(#paint1_linear_8093_13961)", "stroke-width": "0.339806" }), h("rect", { key: "9372b639b3aecde11c0dcf1ed7791b88c97d3e06", x: "0.169903", y: "16.5", width: "39.6602", height: "39.6602", rx: "8.76214", fill: "url(#paint2_linear_8093_13961)", stroke: "url(#paint3_linear_8093_13961)", "stroke-width": "0.339806" }), h("g", { key: "8cd8147e8871838e1f385e14011d057cbd81ee2b", filter: "url(#filter0_dddd_8093_13961)" }, h("path", { key: "11ca1054ab2c9b4bf8a20e82d1962a17fc806aa5", d: "M13.1387 26.2337L18.8354 23.1782L17.8776 21.3301L12.6614 23.4483C12.527 23.5029 12.3781 23.5029 12.2438 23.4483L7.02607 21.3301L6.06836 23.1782L11.765 26.2337L6.06836 29.2878L7.02607 31.1359L12.2423 29.0177C12.3767 28.9631 12.5256 28.9631 12.6599 29.0177L17.8762 31.1359L18.8339 29.2878L13.1373 26.2323L13.1387 26.2337Z", fill: "#000F0E" }))), h("g", { key: "6f73b57b3f3b869fb3f43731f2515783d17bbd9c", "clip-path": "url(#clip0_8093_13961)" }, h("path", { key: "29911f3213b6253685fb0c0dd2c159d86e001eb0", d: "M38 11.998C40.2091 11.998 42 10.2072 42 7.99805C42 5.78891 40.2091 3.99805 38 3.99805C35.7909 3.99805 34 5.78891 34 7.99805C34 10.2072 35.7909 11.998 38 11.998Z", fill: "white" }), h("path", { key: "4d4870a9b144c71f686ec9ee9c30b3b55e87a263", d: "M37.9998 4.00001H44.9269C44.225 2.78381 43.2152 1.77385 41.9991 1.07168C40.783 0.369518 39.4035 -9.79568e-05 37.9993 1.94733e-08C36.5951 9.79957e-05 35.2156 0.369906 33.9996 1.07224C32.7837 1.77457 31.774 2.78468 31.0723 4.00098L34.5358 10L34.5389 9.99921C34.1866 9.39164 34.0006 8.70191 33.9998 7.99957C33.9991 7.29722 34.1834 6.60708 34.5344 5.99872C34.8854 5.39035 35.3905 4.88526 35.9989 4.53436C36.6073 4.18346 37.2975 3.99915 37.9998 4.00001Z", fill: "url(#paint4_linear_8093_13961)" }), h("path", { key: "3660e669627b2e9f3a2ac4a818b6966a700cbd15", d: "M38.0007 11.1668C39.7496 11.1668 41.1673 9.74906 41.1673 8.00016C41.1673 6.25126 39.7496 4.8335 38.0007 4.8335C36.2517 4.8335 34.834 6.25126 34.834 8.00016C34.834 9.74906 36.2517 11.1668 38.0007 11.1668Z", fill: "#1A73E8" }), h("path", { key: "f71bf19119da18f8f31fa4eda5b304229eb451d2", d: "M41.463 10.0009L37.9995 15.9999C39.4037 16.0001 40.7832 15.6306 41.9994 14.9285C43.2155 14.2265 44.2253 13.2166 44.9273 12.0004C45.6294 10.7843 45.9988 9.40474 45.9986 8.00051C45.9983 6.59629 45.6284 5.21687 44.9259 4.00098H37.9989L37.998 4.00408C38.7004 4.00272 39.3907 4.18655 39.9993 4.53704C40.608 4.88752 41.1135 5.39227 41.4649 6.0004C41.8162 6.60854 42.0011 7.29856 42.0008 8.0009C42.0004 8.70325 41.815 9.3931 41.463 10.0009Z", fill: "url(#paint5_linear_8093_13961)" }), h("path", { key: "133899abd8c95b1a0ec6b45912ac2aa2b1ccea9a", d: "M34.5356 10.001L31.0721 4.00195C30.3698 5.21795 30.0001 6.59742 30 8.00166C29.9999 9.40589 30.3696 10.7854 31.0718 12.0014C31.774 13.2175 32.784 14.2272 34.0002 14.9291C35.2165 15.631 36.596 16.0004 38.0003 16L41.4638 10.0009L41.4616 9.99865C41.1116 10.6076 40.6072 11.1135 39.9994 11.4653C39.3915 11.8172 38.7016 12.0026 37.9993 12.0028C37.2969 12.003 36.6069 11.8181 35.9988 11.4667C35.3908 11.1152 34.8861 10.6097 34.5356 10.001Z", fill: "url(#paint6_linear_8093_13961)" })), h("defs", { key: "d8cc8f7d090638cf6ec097c97887e62e6c9d030e" }, h("filter", { key: "02e6286429b547d54deae56b7738f6f58aeb97f3", id: "filter0_dddd_8093_13961", x: "-4.9996", y: "12.398", width: "34.9035", height: "31.9416", filterUnits: "userSpaceOnUse", "color-interpolation-filters": "sRGB" }, h("feFlood", { key: "ffcfad0f6f5ca7059320a39bcaef2bdcce96427d", "flood-opacity": "0", result: "BackgroundImageFix" }), h("feColorMatrix", { key: "ebf5905f193387247fd21f6457fa1fd5f592e6cd", in: "SourceAlpha", type: "matrix", values: "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 127 0", result: "hardAlpha" }), h("feOffset", { key: "47a10b2fed727321fe0a2db81b918302eb6c60cd", dy: "0.970874" }), h("feGaussianBlur", { key: "b9d716f216a6e1969032e97523131c1e0851f6ce", stdDeviation: "1.26214" }), h("feComposite", { key: "c1e435138c1f30ca46859b1f8c576baca0724907", in2: "hardAlpha", operator: "out" }), h("feColorMatrix", { key: "323272a4b20e8d20f13e7dc28cea0b2d60526efa", type: "matrix", values: "0 0 0 0 0.137255 0 0 0 0 0.968627 0 0 0 0 0.866667 0 0 0 0.1 0" }), h("feBlend", { key: "51f3cc1f8c7a1c34e1565ef82252732209662516", mode: "normal", in2: "BackgroundImageFix", result: "effect1_dropShadow_8093_13961" }), h("feColorMatrix", { key: "0741c23ea29b0cc88c4555066d7c31a91c626289", in: "SourceAlpha", type: "matrix", values: "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 127 0", result: "hardAlpha" }), h("feOffset", { key: "431f7e9c2c75d41ae349fd1fe66f21404df916a4", dy: "2.13592" }), h("feGaussianBlur", { key: "29bbc6b2d2eefcd4be78c55955a653560e227da2", stdDeviation: "5.53398" }), h("feComposite", { key: "5cc63e9f14f7f163f02d71e1ecee5363d2aedd98", in2: "hardAlpha", operator: "out" }), h("feColorMatrix", { key: "45657e5f902154e084639c8ce5647251997f6348", type: "matrix", values: "0 0 0 0 0.137255 0 0 0 0 0.968627 0 0 0 0 0.866667 0 0 0 0.3 0" }), h("feBlend", { key: "c434470476f1862a0a53f87e502d811fcc83de0c", mode: "normal", in2: "effect1_dropShadow_8093_13961", result: "effect2_dropShadow_8093_13961" }), h("feColorMatrix", { key: "764c4de3a36ec774450d219df90bfe870a3c392c", in: "SourceAlpha", type: "matrix", values: "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 127 0", result: "hardAlpha" }), h("feOffset", { key: "52af200823b06cf80c4b303ed5ef9393590cb15f", dy: "0.291262" }), h("feGaussianBlur", { key: "14a9fb778fe1d22789a08d6624a23bb4c0b64140", stdDeviation: "0.533981" }), h("feComposite", { key: "dd0864758646a98280a90f3aea1a6ef3b834c3c6", in2: "hardAlpha", operator: "out" }), h("feColorMatrix", { key: "15015b7b9a666083e81a73ed9811444415b92f1c", type: "matrix", values: "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0.35 0" }), h("feBlend", { key: "7f45c2f30aade454141f3126ac53c6e8c3b2309f", mode: "normal", in2: "effect2_dropShadow_8093_13961", result: "effect3_dropShadow_8093_13961" }), h("feColorMatrix", { key: "3d0478ecad0d3490d4d3ef7e1d7510263951bbe3", in: "SourceAlpha", type: "matrix", values: "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 127 0", result: "hardAlpha" }), h("feOffset", { key: "b4c08bef00b76d2c63b644ee7b1e0835642483c9", dy: "0.194175" }), h("feGaussianBlur", { key: "bec7418e0d3f9750795c63d07dc7cb1f3e64c286", stdDeviation: "0.0970874" }), h("feComposite", { key: "a5881c3ba395e6ff68ea2d0dc6a3140e65074007", in2: "hardAlpha", operator: "out" }), h("feColorMatrix", { key: "6041a8e8d068dfb5e1a2d5c62908bed357d63dfa", type: "matrix", values: "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0.25 0" }), h("feBlend", { key: "c13c0f7d7f564c5c54a36b3c269dd76464aeba77", mode: "normal", in2: "effect3_dropShadow_8093_13961", result: "effect4_dropShadow_8093_13961" }), h("feBlend", { key: "2df160ea93369056ebe7be9e52ddd43c0c389ee4", mode: "normal", in: "SourceGraphic", in2: "effect4_dropShadow_8093_13961", result: "shape" })), h("linearGradient", { key: "5660197e975b7375d98f4da627afa9bedb678688", id: "paint0_linear_8093_13961", x1: "20.2306", y1: "19.1846", x2: "20.2306", y2: "39.6748", gradientUnits: "userSpaceOnUse" }, h("stop", { key: "8bfdb527fa78c608eda26e27f02d2f6263b511f8", "stop-color": "#00FFE0" }), h("stop", { key: "6910f5ed4ea24fec7621cada660151d6031990c6", offset: "1", "stop-color": "#00FFE0" })), h("linearGradient", { key: "000b98163ae12576827037daa49c92cac9cc5547", id: "paint1_linear_8093_13961", x1: "6.49826", y1: "30.7502", x2: "42.1154", y2: "27.4436", gradientUnits: "userSpaceOnUse" }, h("stop", { key: "a2dda5ecf6e96e985cc6ccab3f493abf22328e67", "stop-color": "#00FFE0" }), h("stop", { key: "fa43f1b137be6b7746a0bde98f6d614316909ab6", offset: "1", "stop-color": "#4CFFE9" })), h("linearGradient", { key: "0754b137ceca72f1f111b42640c8e36a858fc32a", id: "paint2_linear_8093_13961", x1: "20.2306", y1: "25.3497", x2: "20.2306", y2: "45.8399", gradientUnits: "userSpaceOnUse" }, h("stop", { key: "3abdc367f6cd6b36040d5f26372c531d8fcae94c", "stop-color": "#00FFE0" }), h("stop", { key: "eb997eb137d3a0d7c0c57f9e46ec3588dd29f2af", offset: "1", "stop-color": "#00FFE0" })), h("linearGradient", { key: "dc0fe7ab4c80cab026e848bc25b127c77c30d0d8", id: "paint3_linear_8093_13961", x1: "6.49826", y1: "36.9152", x2: "42.1154", y2: "33.6087", gradientUnits: "userSpaceOnUse" }, h("stop", { key: "591152ce5e27c2789d94d7807112278d5c529bc3", "stop-color": "#00FFE0" }), h("stop", { key: "8e82ec633f26be4770112b5f55e5e5efba3be42a", offset: "1", "stop-color": "#4CFFE9" })), h("linearGradient", { key: "ed8051a6433122ab20adc1a3d10f93b58f247879", id: "paint4_linear_8093_13961", x1: "31.0723", y1: "5.00001", x2: "44.9269", y2: "5.00001", gradientUnits: "userSpaceOnUse" }, h("stop", { key: "a4e12fa5feefe0e9275513e3bb5ea0a708b03f9c", "stop-color": "#D93025" }), h("stop", { key: "6182c124349402c94486fb7f771ac8e651418368", offset: "1", "stop-color": "#EA4335" })), h("linearGradient", { key: "7b2de6e04739b06cfb479e495e43d4aa3743a13c", id: "paint5_linear_8093_13961", x1: "36.9065", y1: "15.893", x2: "43.8339", y2: "3.89451", gradientUnits: "userSpaceOnUse" }, h("stop", { key: "6df2b78827a192d39816e115c91144d7268213ae", "stop-color": "#FCC934" }), h("stop", { key: "94b73d88ff2cb6dce50c136343b2a3a72d65efda", offset: "1", "stop-color": "#FBBC04" })), h("linearGradient", { key: "9cc1b9b94a5bd7fe4efa1e6af06899c99376bf5c", id: "paint6_linear_8093_13961", x1: "38.8655", y1: "15.5005", x2: "31.9381", y2: "3.50195", gradientUnits: "userSpaceOnUse" }, h("stop", { key: "7c5d1e4acb37144b98a83c0d5ebcb2f8a1cf2dfc", "stop-color": "#1E8E3E" }), h("stop", { key: "5bc77170d793c0fc2754629c2cdd26d9f634da6f", offset: "1", "stop-color": "#34A853" })), h("clipPath", { key: "281ee25fc1d7f50699c6eda38b313d2a4dd43a90", id: "clip0_8093_13961" }, h("rect", { key: "789ab56ea8d0f625fddbf7bb5a609f092fa17672", width: "16", height: "16", fill: "white", transform: "translate(30)" })))));
    }
};

ExtensionProviderIcon.style = '/*! tailwindcss v4.1.3 | MIT License | https://tailwindcss.com */@layer theme{:root,:host{--mvx-font-sans:ui-sans-serif,system-ui,sans-serif,"Apple Color Emoji","Segoe UI Emoji","Segoe UI Symbol","Noto Color Emoji";--mvx-font-mono:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,"Liberation Mono","Courier New",monospace;--mvx-default-font-family:var(--mvx-font-sans);--mvx-default-mono-font-family:var(--mvx-font-mono)}}@layer base{*,:after,:before,::backdrop{box-sizing:border-box;border:0 solid;margin:0;padding:0}::file-selector-button{box-sizing:border-box;border:0 solid;margin:0;padding:0}html,:host{-webkit-text-size-adjust:100%;tab-size:4;line-height:1.5;font-family:var(--mvx-default-font-family,ui-sans-serif,system-ui,sans-serif,"Apple Color Emoji","Segoe UI Emoji","Segoe UI Symbol","Noto Color Emoji");font-feature-settings:var(--mvx-default-font-feature-settings,normal);font-variation-settings:var(--mvx-default-font-variation-settings,normal);-webkit-tap-highlight-color:transparent}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;-webkit-text-decoration:inherit;-webkit-text-decoration:inherit;-webkit-text-decoration:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:var(--mvx-default-mono-font-family,ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,"Liberation Mono","Courier New",monospace);font-feature-settings:var(--mvx-default-mono-font-feature-settings,normal);font-variation-settings:var(--mvx-default-mono-font-variation-settings,normal);font-size:1em}small{font-size:80%}sub,sup{vertical-align:baseline;font-size:75%;line-height:0;position:relative}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}:-moz-focusring{outline:auto}progress{vertical-align:baseline}summary{display:list-item}ol,ul,menu{list-style:none}img,svg,video,canvas,audio,iframe,embed,object{vertical-align:middle;display:block}img,video{max-width:100%;height:auto}button,input,select,optgroup,textarea{font:inherit;font-feature-settings:inherit;font-variation-settings:inherit;letter-spacing:inherit;color:inherit;opacity:1;background-color:#0000;border-radius:0}::file-selector-button{font:inherit;font-feature-settings:inherit;font-variation-settings:inherit;letter-spacing:inherit;color:inherit;opacity:1;background-color:#0000;border-radius:0}:where(select:is([multiple],[size])) optgroup{font-weight:bolder}:where(select:is([multiple],[size])) optgroup option{padding-inline-start:20px}::file-selector-button{margin-inline-end:4px}::placeholder{opacity:1}@supports (not ((-webkit-appearance:-apple-pay-button))) or (contain-intrinsic-size:1px){::placeholder{color:currentColor}@supports (color:color-mix(in lab, red, red)){::placeholder{color:color-mix(in oklab,currentColor 50%,transparent)}}}textarea{resize:vertical}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-date-and-time-value{min-height:1lh;text-align:inherit}::-webkit-datetime-edit{display:inline-flex}::-webkit-datetime-edit-fields-wrapper{padding:0}::-webkit-datetime-edit{padding-block:0}::-webkit-datetime-edit-year-field{padding-block:0}::-webkit-datetime-edit-month-field{padding-block:0}::-webkit-datetime-edit-day-field{padding-block:0}::-webkit-datetime-edit-hour-field{padding-block:0}::-webkit-datetime-edit-minute-field{padding-block:0}::-webkit-datetime-edit-second-field{padding-block:0}::-webkit-datetime-edit-millisecond-field{padding-block:0}::-webkit-datetime-edit-meridiem-field{padding-block:0}:-moz-ui-invalid{box-shadow:none}button,input:where([type=button],[type=reset],[type=submit]){appearance:button}::file-selector-button{appearance:button}::-webkit-inner-spin-button{height:auto}::-webkit-outer-spin-button{height:auto}[hidden]:where(:not([hidden=until-found])){display:none!important}}@layer components,utilities; ';

const LedgerProviderIcon = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
    }
    render() {
        return (h("svg", { key: "c8f1e765b1a1576b177427eee1505f8947130776", xmlns: "http://www.w3.org/2000/svg", width: "40", height: "40", viewBox: "0 0 40 40", fill: "none" }, h("path", { key: "2d8626fc1c0812a8e4c713f1d1ece63f72cc884d", d: "M0.5 20.3198C0.5 15.5916 0.501062 12.0958 0.861658 9.41373C1.22032 6.74604 1.9264 4.95839 3.28249 3.60231C4.63857 2.24623 6.42621 1.54014 9.09391 1.18148C11.776 0.820886 15.2718 0.819824 20 0.819824C24.7282 0.819824 28.224 0.820886 30.9061 1.18148C33.5738 1.54014 35.3614 2.24623 36.7175 3.60231C38.0736 4.95839 38.7797 6.74604 39.1383 9.41373C39.4989 12.0958 39.5 15.5916 39.5 20.3198C39.5 25.048 39.4989 28.5438 39.1383 31.2259C38.7797 33.8936 38.0736 35.6813 36.7175 37.0373C35.3614 38.3934 33.5738 39.0995 30.9061 39.4582C28.224 39.8188 24.7282 39.8198 20 39.8198C15.2718 39.8198 11.776 39.8188 9.09391 39.4582C6.42621 39.0995 4.63857 38.3934 3.28249 37.0373C1.9264 35.6813 1.22032 33.8936 0.861658 31.2259C0.501062 28.5438 0.5 25.048 0.5 20.3198Z", fill: "#171717" }), h("path", { key: "36a1f3c76f97e5e2e586ebef6d6b4a465ae1ea68", d: "M0.5 20.3198C0.5 15.5916 0.501062 12.0958 0.861658 9.41373C1.22032 6.74604 1.9264 4.95839 3.28249 3.60231C4.63857 2.24623 6.42621 1.54014 9.09391 1.18148C11.776 0.820886 15.2718 0.819824 20 0.819824C24.7282 0.819824 28.224 0.820886 30.9061 1.18148C33.5738 1.54014 35.3614 2.24623 36.7175 3.60231C38.0736 4.95839 38.7797 6.74604 39.1383 9.41373C39.4989 12.0958 39.5 15.5916 39.5 20.3198C39.5 25.048 39.4989 28.5438 39.1383 31.2259C38.7797 33.8936 38.0736 35.6813 36.7175 37.0373C35.3614 38.3934 33.5738 39.0995 30.9061 39.4582C28.224 39.8188 24.7282 39.8198 20 39.8198C15.2718 39.8198 11.776 39.8188 9.09391 39.4582C6.42621 39.0995 4.63857 38.3934 3.28249 37.0373C1.9264 35.6813 1.22032 33.8936 0.861658 31.2259C0.501062 28.5438 0.5 25.048 0.5 20.3198Z", stroke: "#262626" }), h("path", { key: "c6595ce8a91e5d1b2294f5d6c9f3f8983599edb0", d: "M9 24.6116V29.8823H17.2751V28.7135H10.2057V24.6116H9ZM29.7943 24.6116V28.7135H22.7249V29.882H31V24.6116H29.7943ZM17.2872 16.5906V24.6113H22.7249V23.5572H18.4929V16.5906H17.2872ZM9 11.3198V16.5906H10.2057V12.4885H17.2751V11.3198H9ZM22.7249 11.3198V12.4885H29.7943V16.5906H31V11.3198H22.7249Z", fill: "#FAFAFA", stroke: "#FAFAFA", "stroke-width": "0.5" })));
    }
};

LedgerProviderIcon.style = '/*! tailwindcss v4.1.3 | MIT License | https://tailwindcss.com */@layer theme{:root,:host{--mvx-font-sans:ui-sans-serif,system-ui,sans-serif,"Apple Color Emoji","Segoe UI Emoji","Segoe UI Symbol","Noto Color Emoji";--mvx-font-mono:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,"Liberation Mono","Courier New",monospace;--mvx-default-font-family:var(--mvx-font-sans);--mvx-default-mono-font-family:var(--mvx-font-mono)}}@layer base{*,:after,:before,::backdrop{box-sizing:border-box;border:0 solid;margin:0;padding:0}::file-selector-button{box-sizing:border-box;border:0 solid;margin:0;padding:0}html,:host{-webkit-text-size-adjust:100%;tab-size:4;line-height:1.5;font-family:var(--mvx-default-font-family,ui-sans-serif,system-ui,sans-serif,"Apple Color Emoji","Segoe UI Emoji","Segoe UI Symbol","Noto Color Emoji");font-feature-settings:var(--mvx-default-font-feature-settings,normal);font-variation-settings:var(--mvx-default-font-variation-settings,normal);-webkit-tap-highlight-color:transparent}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;-webkit-text-decoration:inherit;-webkit-text-decoration:inherit;-webkit-text-decoration:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:var(--mvx-default-mono-font-family,ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,"Liberation Mono","Courier New",monospace);font-feature-settings:var(--mvx-default-mono-font-feature-settings,normal);font-variation-settings:var(--mvx-default-mono-font-variation-settings,normal);font-size:1em}small{font-size:80%}sub,sup{vertical-align:baseline;font-size:75%;line-height:0;position:relative}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}:-moz-focusring{outline:auto}progress{vertical-align:baseline}summary{display:list-item}ol,ul,menu{list-style:none}img,svg,video,canvas,audio,iframe,embed,object{vertical-align:middle;display:block}img,video{max-width:100%;height:auto}button,input,select,optgroup,textarea{font:inherit;font-feature-settings:inherit;font-variation-settings:inherit;letter-spacing:inherit;color:inherit;opacity:1;background-color:#0000;border-radius:0}::file-selector-button{font:inherit;font-feature-settings:inherit;font-variation-settings:inherit;letter-spacing:inherit;color:inherit;opacity:1;background-color:#0000;border-radius:0}:where(select:is([multiple],[size])) optgroup{font-weight:bolder}:where(select:is([multiple],[size])) optgroup option{padding-inline-start:20px}::file-selector-button{margin-inline-end:4px}::placeholder{opacity:1}@supports (not ((-webkit-appearance:-apple-pay-button))) or (contain-intrinsic-size:1px){::placeholder{color:currentColor}@supports (color:color-mix(in lab, red, red)){::placeholder{color:color-mix(in oklab,currentColor 50%,transparent)}}}textarea{resize:vertical}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-date-and-time-value{min-height:1lh;text-align:inherit}::-webkit-datetime-edit{display:inline-flex}::-webkit-datetime-edit-fields-wrapper{padding:0}::-webkit-datetime-edit{padding-block:0}::-webkit-datetime-edit-year-field{padding-block:0}::-webkit-datetime-edit-month-field{padding-block:0}::-webkit-datetime-edit-day-field{padding-block:0}::-webkit-datetime-edit-hour-field{padding-block:0}::-webkit-datetime-edit-minute-field{padding-block:0}::-webkit-datetime-edit-second-field{padding-block:0}::-webkit-datetime-edit-millisecond-field{padding-block:0}::-webkit-datetime-edit-meridiem-field{padding-block:0}:-moz-ui-invalid{box-shadow:none}button,input:where([type=button],[type=reset],[type=submit]){appearance:button}::file-selector-button{appearance:button}::-webkit-inner-spin-button{height:auto}::-webkit-outer-spin-button{height:auto}[hidden]:where(:not([hidden=until-found])){display:none!important}}@layer components,utilities; ';

const MetaMaskProviderIcon = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
    }
    render() {
        return (h("svg", { key: "e9d1aa1b750f3b5a02456d9707fcf5a0a67f5678", xmlns: "http://www.w3.org/2000/svg", viewBox: "0 0 40 40", width: "40", height: "40", fill: "none" }, h("path", { key: "b39306d6639bae5d952542be2988c496977ade8d", d: "M0.5 20.3198C0.5 15.5916 0.501062 12.0958 0.861658 9.41373C1.22032 6.74604 1.9264 4.95839 3.28249 3.60231C4.63857 2.24623 6.42621 1.54014 9.09391 1.18148C11.776 0.820886 15.2718 0.819824 20 0.819824C24.7282 0.819824 28.224 0.820886 30.9061 1.18148C33.5738 1.54014 35.3614 2.24623 36.7175 3.60231C38.0736 4.95839 38.7797 6.74604 39.1383 9.41373C39.4989 12.0958 39.5 15.5916 39.5 20.3198C39.5 25.048 39.4989 28.5438 39.1383 31.2259C38.7797 33.8936 38.0736 35.6813 36.7175 37.0373C35.3614 38.3934 33.5738 39.0995 30.9061 39.4582C28.224 39.8188 24.7282 39.8198 20 39.8198C15.2718 39.8198 11.776 39.8188 9.09391 39.4582C6.42621 39.0995 4.63857 38.3934 3.28249 37.0373C1.9264 35.6813 1.22032 33.8936 0.861658 31.2259C0.501062 28.5438 0.5 25.048 0.5 20.3198Z", fill: "#171717" }), h("path", { key: "b66e4d6a5fe07c79daab768763965ec723abfa4e", d: "M0.5 20.3198C0.5 15.5916 0.501062 12.0958 0.861658 9.41373C1.22032 6.74604 1.9264 4.95839 3.28249 3.60231C4.63857 2.24623 6.42621 1.54014 9.09391 1.18148C11.776 0.820886 15.2718 0.819824 20 0.819824C24.7282 0.819824 28.224 0.820886 30.9061 1.18148C33.5738 1.54014 35.3614 2.24623 36.7175 3.60231C38.0736 4.95839 38.7797 6.74604 39.1383 9.41373C39.4989 12.0958 39.5 15.5916 39.5 20.3198C39.5 25.048 39.4989 28.5438 39.1383 31.2259C38.7797 33.8936 38.0736 35.6813 36.7175 37.0373C35.3614 38.3934 33.5738 39.0995 30.9061 39.4582C28.224 39.8188 24.7282 39.8198 20 39.8198C15.2718 39.8198 11.776 39.8188 9.09391 39.4582C6.42621 39.0995 4.63857 38.3934 3.28249 37.0373C1.9264 35.6813 1.22032 33.8936 0.861658 31.2259C0.501062 28.5438 0.5 25.048 0.5 20.3198Z", stroke: "#404040" }), h("g", { key: "79934def71cdd108e37548b5e9959b9fdc877f4f", "clip-path": "url(#clip0_7913_4125)" }, h("path", { key: "87f99a3805c8d3e73ac037eca6c4715c641fea1f", d: "M30.7562 9.36475L21.8516 15.9784L23.4983 12.0764L30.7562 9.36475Z", fill: "#E2761B", stroke: "#E2761B", "stroke-width": "0.0894942", "stroke-linecap": "round", "stroke-linejoin": "round" }), h("path", { key: "e53041fc8ac6bc33a3e20b49e6f3cc33469f307c", d: "M10.1995 9.36475L19.0325 16.041L17.4664 12.0764L10.1995 9.36475ZM27.5524 24.6951L25.1808 28.3286L30.2551 29.7247L31.7139 24.7756L27.5524 24.6951ZM9.25977 24.7756L10.7096 29.7247L15.7839 28.3286L13.4123 24.6951L9.25977 24.7756Z", fill: "#E4761B", stroke: "#E4761B", "stroke-width": "0.0894942", "stroke-linecap": "round", "stroke-linejoin": "round" }), h("path", { key: "ffb26e5afc0ccc513dc059c3480b5d9904b246a4", d: "M15.4975 18.5558L14.0835 20.6947L19.122 20.9184L18.943 15.5041L15.4975 18.5558ZM25.4582 18.5558L21.9679 15.4414L21.8516 20.9184L26.8812 20.6947L25.4582 18.5558ZM15.7839 28.3286L18.8088 26.8519L16.1956 24.8114L15.7839 28.3286ZM22.1469 26.8519L25.1808 28.3286L24.7601 24.8114L22.1469 26.8519Z", fill: "#E4761B", stroke: "#E4761B", "stroke-width": "0.0894942", "stroke-linecap": "round", "stroke-linejoin": "round" }), h("path", { key: "87331f5c22bd62894e684513acb9effbd102616a", d: "M25.1811 28.3287L22.1472 26.8521L22.3888 28.8299L22.362 29.6622L25.1811 28.3287ZM15.7842 28.3287L18.6032 29.6622L18.5853 28.8299L18.8091 26.8521L15.7842 28.3287Z", fill: "#D7C1B3", stroke: "#D7C1B3", "stroke-width": "0.0894942", "stroke-linecap": "round", "stroke-linejoin": "round" }), h("path", { key: "9b292c30c4e67fbfb6e9edf00b789d5d620cf9dd", d: "M18.6478 23.505L16.124 22.7622L17.905 21.9478L18.6478 23.505ZM22.3081 23.505L23.0509 21.9478L24.8408 22.7622L22.3081 23.505Z", fill: "#233447", stroke: "#233447", "stroke-width": "0.0894942", "stroke-linecap": "round", "stroke-linejoin": "round" }), h("path", { key: "0a4435bc8e602e8e35c065ede5be7eb95d7879b4", d: "M15.7842 28.3282L16.2138 24.6947L13.4126 24.7753L15.7842 28.3282ZM24.7515 24.6947L25.1811 28.3282L27.5527 24.7753L24.7515 24.6947ZM26.8815 20.6943L21.8519 20.9181L22.3173 23.5045L23.0601 21.9473L24.85 22.7617L26.8815 20.6943ZM16.1243 22.7617L17.9142 21.9473L18.648 23.5045L19.1223 20.9181L14.0838 20.6943L16.1243 22.7617Z", fill: "#CD6116", stroke: "#CD6116", "stroke-width": "0.0894942", "stroke-linecap": "round", "stroke-linejoin": "round" }), h("path", { key: "bad7787d6446d30ba1e78f63a3a7014fe76bd332", d: "M14.0835 20.6943L16.1956 24.8111L16.124 22.7617L14.0835 20.6943ZM24.8496 22.7617L24.7601 24.8111L26.8812 20.6943L24.8496 22.7617ZM19.122 20.9181L18.6477 23.5045L19.2384 26.5562L19.3726 22.5379L19.122 20.9181ZM21.8516 20.9181L21.61 22.529L21.7173 26.5562L22.317 23.5045L21.8516 20.9181Z", fill: "#E4751F", stroke: "#E4751F", "stroke-width": "0.0894942", "stroke-linecap": "round", "stroke-linejoin": "round" }), h("path", { key: "1dbddd16ee87ffb7efbb4111a22f944cd58dd406", d: "M22.317 23.5045L21.7174 26.5563L22.147 26.8516L24.7602 24.8111L24.8497 22.7617L22.317 23.5045ZM16.124 22.7617L16.1956 24.8111L18.8088 26.8516L19.2384 26.5563L18.6478 23.5045L16.124 22.7617Z", fill: "#F6851B", stroke: "#F6851B", "stroke-width": "0.0894942", "stroke-linecap": "round", "stroke-linejoin": "round" }), h("path", { key: "64721a79ee82308c5b1965c618ca5e4e4dc50177", d: "M22.362 29.6616L22.3888 28.8293L22.1651 28.6324H18.7912L18.5853 28.8293L18.6032 29.6616L15.7842 28.3281L16.7686 29.1336L18.7643 30.5207H22.192L24.1966 29.1336L25.1811 28.3281L22.362 29.6616Z", fill: "#C0AD9E", stroke: "#C0AD9E", "stroke-width": "0.0894942", "stroke-linecap": "round", "stroke-linejoin": "round" }), h("path", { key: "26615509ecbf635d7f8352945ce0ba02e7713e83", d: "M22.1468 26.852L21.7173 26.5566H19.2383L18.8087 26.852L18.585 28.8298L18.7908 28.6329H22.1647L22.3885 28.8298L22.1468 26.852Z", fill: "#161616", stroke: "#161616", "stroke-width": "0.0894942", "stroke-linecap": "round", "stroke-linejoin": "round" }), h("path", { key: "c69913ce7a487e9093bc40596c21e190b6dbe07d", d: "M31.1326 16.4079L31.8933 12.7566L30.7567 9.36475L22.1474 15.7546L25.4586 18.5558L30.1392 19.9251L31.1773 18.7169L30.7299 18.3947L31.4458 17.7414L30.8909 17.3118L31.6069 16.7659L31.1326 16.4079ZM9.07227 12.7566L9.83297 16.4079L9.3497 16.7659L10.0657 17.3118L9.51974 17.7414L10.2357 18.3947L9.78822 18.7169L10.8174 19.9251L15.4979 18.5558L18.8092 15.7546L10.1999 9.36475L9.07227 12.7566Z", fill: "#763D16", stroke: "#763D16", "stroke-width": "0.0894942", "stroke-linecap": "round", "stroke-linejoin": "round" }), h("path", { key: "037edc592af865c234669b8d4b84a7d07a28b8d5", d: "M30.1388 19.9253L25.4582 18.556L26.8812 20.6949L24.7602 24.8117L27.5524 24.7759H31.7139L30.1388 19.9253ZM15.4975 18.556L10.817 19.9253L9.25977 24.7759H13.4123L16.1956 24.8117L14.0835 20.6949L15.4975 18.556ZM21.8516 20.9187L22.1469 15.7549L23.5072 12.0767H17.4664L18.8088 15.7549L19.122 20.9187L19.2294 22.5475L19.2384 26.5568H21.7174L21.7353 22.5475L21.8516 20.9187Z", fill: "#F6851B", stroke: "#F6851B", "stroke-width": "0.0894942", "stroke-linecap": "round", "stroke-linejoin": "round" })), h("defs", { key: "f9f6d9c662aef907c9c3c756a03ed48ca3162091" }, h("clipPath", { key: "6369d00eaf5240222bbd8a8fa359d1784dcea873", id: "clip0_7913_4125" }, h("rect", { key: "1255b51dbf22e49bc87b69e2a25f24b4ba4449f0", width: "23", height: "21.2996", fill: "white", transform: "translate(9 9.31982)" })))));
    }
};

MetaMaskProviderIcon.style = '/*! tailwindcss v4.1.3 | MIT License | https://tailwindcss.com */@layer theme{:root,:host{--mvx-font-sans:ui-sans-serif,system-ui,sans-serif,"Apple Color Emoji","Segoe UI Emoji","Segoe UI Symbol","Noto Color Emoji";--mvx-font-mono:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,"Liberation Mono","Courier New",monospace;--mvx-default-font-family:var(--mvx-font-sans);--mvx-default-mono-font-family:var(--mvx-font-mono)}}@layer base{*,:after,:before,::backdrop{box-sizing:border-box;border:0 solid;margin:0;padding:0}::file-selector-button{box-sizing:border-box;border:0 solid;margin:0;padding:0}html,:host{-webkit-text-size-adjust:100%;tab-size:4;line-height:1.5;font-family:var(--mvx-default-font-family,ui-sans-serif,system-ui,sans-serif,"Apple Color Emoji","Segoe UI Emoji","Segoe UI Symbol","Noto Color Emoji");font-feature-settings:var(--mvx-default-font-feature-settings,normal);font-variation-settings:var(--mvx-default-font-variation-settings,normal);-webkit-tap-highlight-color:transparent}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;-webkit-text-decoration:inherit;-webkit-text-decoration:inherit;-webkit-text-decoration:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:var(--mvx-default-mono-font-family,ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,"Liberation Mono","Courier New",monospace);font-feature-settings:var(--mvx-default-mono-font-feature-settings,normal);font-variation-settings:var(--mvx-default-mono-font-variation-settings,normal);font-size:1em}small{font-size:80%}sub,sup{vertical-align:baseline;font-size:75%;line-height:0;position:relative}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}:-moz-focusring{outline:auto}progress{vertical-align:baseline}summary{display:list-item}ol,ul,menu{list-style:none}img,svg,video,canvas,audio,iframe,embed,object{vertical-align:middle;display:block}img,video{max-width:100%;height:auto}button,input,select,optgroup,textarea{font:inherit;font-feature-settings:inherit;font-variation-settings:inherit;letter-spacing:inherit;color:inherit;opacity:1;background-color:#0000;border-radius:0}::file-selector-button{font:inherit;font-feature-settings:inherit;font-variation-settings:inherit;letter-spacing:inherit;color:inherit;opacity:1;background-color:#0000;border-radius:0}:where(select:is([multiple],[size])) optgroup{font-weight:bolder}:where(select:is([multiple],[size])) optgroup option{padding-inline-start:20px}::file-selector-button{margin-inline-end:4px}::placeholder{opacity:1}@supports (not ((-webkit-appearance:-apple-pay-button))) or (contain-intrinsic-size:1px){::placeholder{color:currentColor}@supports (color:color-mix(in lab, red, red)){::placeholder{color:color-mix(in oklab,currentColor 50%,transparent)}}}textarea{resize:vertical}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-date-and-time-value{min-height:1lh;text-align:inherit}::-webkit-datetime-edit{display:inline-flex}::-webkit-datetime-edit-fields-wrapper{padding:0}::-webkit-datetime-edit{padding-block:0}::-webkit-datetime-edit-year-field{padding-block:0}::-webkit-datetime-edit-month-field{padding-block:0}::-webkit-datetime-edit-day-field{padding-block:0}::-webkit-datetime-edit-hour-field{padding-block:0}::-webkit-datetime-edit-minute-field{padding-block:0}::-webkit-datetime-edit-second-field{padding-block:0}::-webkit-datetime-edit-millisecond-field{padding-block:0}::-webkit-datetime-edit-meridiem-field{padding-block:0}:-moz-ui-invalid{box-shadow:none}button,input:where([type=button],[type=reset],[type=submit]){appearance:button}::file-selector-button{appearance:button}::-webkit-inner-spin-button{height:auto}::-webkit-outer-spin-button{height:auto}[hidden]:where(:not([hidden=until-found])){display:none!important}}@layer components,utilities; ';

const MultiversXLogoIcon = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
    }
    render() {
        return (h("svg", { key: "302f090da59efde217adc4cdb681308aefecc1d0", xmlns: "http://www.w3.org/2000/svg", width: "40", height: "40", viewBox: "0 0 40 40", fill: "none" }, h("path", { key: "824fd443dbc2f4a42a370ca24d65ed888303f37f", d: "M0 20.3198C0 10.8917 0 6.17769 2.92893 3.24876C5.85786 0.319824 10.5719 0.319824 20 0.319824C29.4281 0.319824 34.1421 0.319824 37.0711 3.24876C40 6.17769 40 10.8917 40 20.3198C40 29.7479 40 34.462 37.0711 37.3909C34.1421 40.3198 29.4281 40.3198 20 40.3198C10.5719 40.3198 5.85786 40.3198 2.92893 37.3909C0 34.462 0 29.7479 0 20.3198Z", fill: "#23F7DD" }), h("path", { key: "df6c00ba9bd9b9be67184dca906693b2d66f5ee1", d: "M0.5 20.3198C0.5 15.5916 0.501062 12.0958 0.861658 9.41373C1.22032 6.74604 1.9264 4.95839 3.28249 3.60231C4.63857 2.24623 6.42621 1.54014 9.09391 1.18148C11.776 0.820886 15.2718 0.819824 20 0.819824C24.7282 0.819824 28.224 0.820886 30.9061 1.18148C33.5738 1.54014 35.3614 2.24623 36.7175 3.60231C38.0736 4.95839 38.7797 6.74604 39.1383 9.41373C39.4989 12.0958 39.5 15.5916 39.5 20.3198C39.5 25.048 39.4989 28.5438 39.1383 31.2259C38.7797 33.8936 38.0736 35.6813 36.7175 37.0373C35.3614 38.3934 33.5738 39.0995 30.9061 39.4582C28.224 39.8188 24.7282 39.8198 20 39.8198C15.2718 39.8198 11.776 39.8188 9.09391 39.4582C6.42621 39.0995 4.63857 38.3934 3.28249 37.0373C1.9264 35.6813 1.22032 33.8936 0.861658 31.2259C0.501062 28.5438 0.5 25.048 0.5 20.3198Z", stroke: "black", "stroke-opacity": "0.16" }), h("path", { key: "70c20065617546fb5bc792848d4cc4cf58c5f313", d: "M21.7347 20.3209L30.9375 16.0363L29.3903 13.4448L20.9635 16.4151C20.7465 16.4916 20.5059 16.4916 20.2889 16.4151L11.8597 13.4448L10.3125 16.0363L19.5153 20.3209L10.3125 24.6034L11.8597 27.1948L20.2866 24.2246C20.5036 24.148 20.7441 24.148 20.9611 24.2246L29.388 27.1948L30.9352 24.6034L21.7323 20.3188L21.7347 20.3209Z", fill: "black" })));
    }
};

MultiversXLogoIcon.style = '/*! tailwindcss v4.1.3 | MIT License | https://tailwindcss.com */@layer theme{:root,:host{--mvx-font-sans:ui-sans-serif,system-ui,sans-serif,"Apple Color Emoji","Segoe UI Emoji","Segoe UI Symbol","Noto Color Emoji";--mvx-font-mono:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,"Liberation Mono","Courier New",monospace;--mvx-default-font-family:var(--mvx-font-sans);--mvx-default-mono-font-family:var(--mvx-font-mono)}}@layer base{*,:after,:before,::backdrop{box-sizing:border-box;border:0 solid;margin:0;padding:0}::file-selector-button{box-sizing:border-box;border:0 solid;margin:0;padding:0}html,:host{-webkit-text-size-adjust:100%;tab-size:4;line-height:1.5;font-family:var(--mvx-default-font-family,ui-sans-serif,system-ui,sans-serif,"Apple Color Emoji","Segoe UI Emoji","Segoe UI Symbol","Noto Color Emoji");font-feature-settings:var(--mvx-default-font-feature-settings,normal);font-variation-settings:var(--mvx-default-font-variation-settings,normal);-webkit-tap-highlight-color:transparent}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;-webkit-text-decoration:inherit;-webkit-text-decoration:inherit;-webkit-text-decoration:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:var(--mvx-default-mono-font-family,ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,"Liberation Mono","Courier New",monospace);font-feature-settings:var(--mvx-default-mono-font-feature-settings,normal);font-variation-settings:var(--mvx-default-mono-font-variation-settings,normal);font-size:1em}small{font-size:80%}sub,sup{vertical-align:baseline;font-size:75%;line-height:0;position:relative}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}:-moz-focusring{outline:auto}progress{vertical-align:baseline}summary{display:list-item}ol,ul,menu{list-style:none}img,svg,video,canvas,audio,iframe,embed,object{vertical-align:middle;display:block}img,video{max-width:100%;height:auto}button,input,select,optgroup,textarea{font:inherit;font-feature-settings:inherit;font-variation-settings:inherit;letter-spacing:inherit;color:inherit;opacity:1;background-color:#0000;border-radius:0}::file-selector-button{font:inherit;font-feature-settings:inherit;font-variation-settings:inherit;letter-spacing:inherit;color:inherit;opacity:1;background-color:#0000;border-radius:0}:where(select:is([multiple],[size])) optgroup{font-weight:bolder}:where(select:is([multiple],[size])) optgroup option{padding-inline-start:20px}::file-selector-button{margin-inline-end:4px}::placeholder{opacity:1}@supports (not ((-webkit-appearance:-apple-pay-button))) or (contain-intrinsic-size:1px){::placeholder{color:currentColor}@supports (color:color-mix(in lab, red, red)){::placeholder{color:color-mix(in oklab,currentColor 50%,transparent)}}}textarea{resize:vertical}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-date-and-time-value{min-height:1lh;text-align:inherit}::-webkit-datetime-edit{display:inline-flex}::-webkit-datetime-edit-fields-wrapper{padding:0}::-webkit-datetime-edit{padding-block:0}::-webkit-datetime-edit-year-field{padding-block:0}::-webkit-datetime-edit-month-field{padding-block:0}::-webkit-datetime-edit-day-field{padding-block:0}::-webkit-datetime-edit-hour-field{padding-block:0}::-webkit-datetime-edit-minute-field{padding-block:0}::-webkit-datetime-edit-second-field{padding-block:0}::-webkit-datetime-edit-millisecond-field{padding-block:0}::-webkit-datetime-edit-meridiem-field{padding-block:0}:-moz-ui-invalid{box-shadow:none}button,input:where([type=button],[type=reset],[type=submit]){appearance:button}::file-selector-button{appearance:button}::-webkit-inner-spin-button{height:auto}::-webkit-outer-spin-button{height:auto}[hidden]:where(:not([hidden=until-found])){display:none!important}}@layer components,utilities; ';

const PasskeyProviderIcon = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
    }
    render() {
        return (h("svg", { key: "bb34b0af80703dc87faca35f0bcbb629bb6f0069", xmlns: "http://www.w3.org/2000/svg", width: "40", height: "40", viewBox: "0 0 40 40", fill: "none" }, h("path", { key: "f7a8597869685a79cf0417bffb9c70d751216a52", d: "M0.5 20.3198C0.5 15.5916 0.501062 12.0958 0.861658 9.41373C1.22032 6.74604 1.9264 4.95839 3.28249 3.60231C4.63857 2.24623 6.42621 1.54014 9.09391 1.18148C11.776 0.820886 15.2718 0.819824 20 0.819824C24.7282 0.819824 28.224 0.820886 30.9061 1.18148C33.5738 1.54014 35.3614 2.24623 36.7175 3.60231C38.0736 4.95839 38.7797 6.74604 39.1383 9.41373C39.4989 12.0958 39.5 15.5916 39.5 20.3198C39.5 25.048 39.4989 28.5438 39.1383 31.2259C38.7797 33.8936 38.0736 35.6813 36.7175 37.0373C35.3614 38.3934 33.5738 39.0995 30.9061 39.4582C28.224 39.8188 24.7282 39.8198 20 39.8198C15.2718 39.8198 11.776 39.8188 9.09391 39.4582C6.42621 39.0995 4.63857 38.3934 3.28249 37.0373C1.9264 35.6813 1.22032 33.8936 0.861658 31.2259C0.501062 28.5438 0.5 25.048 0.5 20.3198Z", fill: "white" }), h("path", { key: "9526c51af9b05d8d63a7fe2c569f6fd1733770c4", d: "M0.5 20.3198C0.5 15.5916 0.501062 12.0958 0.861658 9.41373C1.22032 6.74604 1.9264 4.95839 3.28249 3.60231C4.63857 2.24623 6.42621 1.54014 9.09391 1.18148C11.776 0.820886 15.2718 0.819824 20 0.819824C24.7282 0.819824 28.224 0.820886 30.9061 1.18148C33.5738 1.54014 35.3614 2.24623 36.7175 3.60231C38.0736 4.95839 38.7797 6.74604 39.1383 9.41373C39.4989 12.0958 39.5 15.5916 39.5 20.3198C39.5 25.048 39.4989 28.5438 39.1383 31.2259C38.7797 33.8936 38.0736 35.6813 36.7175 37.0373C35.3614 38.3934 33.5738 39.0995 30.9061 39.4582C28.224 39.8188 24.7282 39.8198 20 39.8198C15.2718 39.8198 11.776 39.8188 9.09391 39.4582C6.42621 39.0995 4.63857 38.3934 3.28249 37.0373C1.9264 35.6813 1.22032 33.8936 0.861658 31.2259C0.501062 28.5438 0.5 25.048 0.5 20.3198Z", stroke: "#E5E5E5" }), h("path", { key: "bbdd107d4b15ff7e376095f793ac71adeb018976", d: "M11.875 20.3198V21.8823C11.875 22.4292 11.4453 22.8198 10.9375 22.8198C10.3906 22.8198 10 22.4292 10 21.8823V20.3198C10 14.812 14.4531 10.3198 20 10.3198C23.0078 10.3198 25.7422 11.687 27.5781 13.8354C27.8906 14.2261 27.8516 14.812 27.4609 15.1636C27.0703 15.4761 26.4844 15.437 26.1328 15.0464C24.6484 13.3276 22.4609 12.1948 20 12.1948C15.5078 12.1948 11.875 15.8667 11.875 20.3198ZM29.7656 18.2886C29.9219 18.9526 30 19.6167 30 20.3198V21.9214C30 22.4292 29.5703 22.8589 29.0625 22.8589C28.5156 22.8589 28.125 22.4292 28.125 21.9214V20.3589C28.125 19.7729 28.0469 19.187 27.9297 18.6401C27.8125 18.1714 28.1641 17.6636 28.6719 17.5464C29.1797 17.4292 29.6484 17.7808 29.7656 18.2886ZM20 13.4448C23.7891 13.4448 26.875 16.5308 26.875 20.3198V21.2964C26.875 22.3901 26.7969 23.4839 26.6797 24.5386C26.6016 25.0073 26.2109 25.3198 25.7422 25.3198C25.1953 25.3198 24.7266 24.812 24.8047 24.2651C24.9219 23.2886 25 22.312 25 21.2964V20.3198C25 17.5854 22.7344 15.3198 20 15.3198C19.5312 15.3198 19.1016 15.3979 18.6719 15.5151C18.2812 15.6323 17.8125 15.5151 17.5391 15.2026C17.1094 14.7339 17.2656 13.9917 17.8516 13.7964C18.5156 13.562 19.2578 13.4448 20 13.4448ZM15.8594 16.1401C16.1719 16.5308 16.1719 17.0776 15.8594 17.4683C15.3125 18.2886 15 19.2651 15 20.3198V21.2964C15 22.4292 14.8438 23.562 14.6094 24.6558C14.5312 25.0464 14.1406 25.3198 13.75 25.3198C13.125 25.3198 12.6562 24.7339 12.8125 24.1089C13.0078 23.2104 13.125 22.2729 13.125 21.2964V20.3198C13.125 18.7573 13.6328 17.2729 14.5312 16.1401C14.8828 15.7104 15.5078 15.7495 15.8594 16.1401ZM23.75 20.3198V21.2964C23.75 22.8589 23.5938 24.4214 23.2812 25.9058C23.2031 26.2964 22.8516 26.5698 22.4609 26.5698C21.9141 26.5698 21.4844 26.062 21.6016 25.5151C21.875 24.1479 22.0312 22.7417 22.0312 21.2964V20.3198C22.0312 19.2261 21.0938 18.2886 20 18.2886C18.8672 18.2886 17.9688 19.2261 17.9688 20.3198V21.2964C17.9688 22.8979 17.7344 24.4604 17.3438 25.9839C17.2266 26.3354 16.9141 26.5698 16.5234 26.5698C15.9375 26.5698 15.5469 26.0229 15.7031 25.437C16.0547 24.1089 16.25 22.7026 16.25 21.2964V20.3198C16.25 18.2495 17.9297 16.5698 20 16.5698C22.0703 16.5698 23.75 18.2495 23.75 20.3198ZM20 19.3823C20.5078 19.3823 20.9375 19.812 20.9375 20.3198V21.2964C20.9375 23.8745 20.4297 26.4136 19.5312 28.8354L19.2969 29.4214C19.1016 29.8901 18.5547 30.1636 18.0859 29.9683C17.6172 29.7729 17.3438 29.2261 17.5391 28.7573L17.7734 28.1714C18.6328 25.9839 19.0625 23.6401 19.0625 21.2964V20.3198C19.0625 19.812 19.4531 19.3823 20 19.3823Z", fill: "#171717" })));
    }
};

PasskeyProviderIcon.style = '/*! tailwindcss v4.1.3 | MIT License | https://tailwindcss.com */@layer theme{:root,:host{--mvx-font-sans:ui-sans-serif,system-ui,sans-serif,"Apple Color Emoji","Segoe UI Emoji","Segoe UI Symbol","Noto Color Emoji";--mvx-font-mono:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,"Liberation Mono","Courier New",monospace;--mvx-default-font-family:var(--mvx-font-sans);--mvx-default-mono-font-family:var(--mvx-font-mono)}}@layer base{*,:after,:before,::backdrop{box-sizing:border-box;border:0 solid;margin:0;padding:0}::file-selector-button{box-sizing:border-box;border:0 solid;margin:0;padding:0}html,:host{-webkit-text-size-adjust:100%;tab-size:4;line-height:1.5;font-family:var(--mvx-default-font-family,ui-sans-serif,system-ui,sans-serif,"Apple Color Emoji","Segoe UI Emoji","Segoe UI Symbol","Noto Color Emoji");font-feature-settings:var(--mvx-default-font-feature-settings,normal);font-variation-settings:var(--mvx-default-font-variation-settings,normal);-webkit-tap-highlight-color:transparent}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;-webkit-text-decoration:inherit;-webkit-text-decoration:inherit;-webkit-text-decoration:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:var(--mvx-default-mono-font-family,ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,"Liberation Mono","Courier New",monospace);font-feature-settings:var(--mvx-default-mono-font-feature-settings,normal);font-variation-settings:var(--mvx-default-mono-font-variation-settings,normal);font-size:1em}small{font-size:80%}sub,sup{vertical-align:baseline;font-size:75%;line-height:0;position:relative}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}:-moz-focusring{outline:auto}progress{vertical-align:baseline}summary{display:list-item}ol,ul,menu{list-style:none}img,svg,video,canvas,audio,iframe,embed,object{vertical-align:middle;display:block}img,video{max-width:100%;height:auto}button,input,select,optgroup,textarea{font:inherit;font-feature-settings:inherit;font-variation-settings:inherit;letter-spacing:inherit;color:inherit;opacity:1;background-color:#0000;border-radius:0}::file-selector-button{font:inherit;font-feature-settings:inherit;font-variation-settings:inherit;letter-spacing:inherit;color:inherit;opacity:1;background-color:#0000;border-radius:0}:where(select:is([multiple],[size])) optgroup{font-weight:bolder}:where(select:is([multiple],[size])) optgroup option{padding-inline-start:20px}::file-selector-button{margin-inline-end:4px}::placeholder{opacity:1}@supports (not ((-webkit-appearance:-apple-pay-button))) or (contain-intrinsic-size:1px){::placeholder{color:currentColor}@supports (color:color-mix(in lab, red, red)){::placeholder{color:color-mix(in oklab,currentColor 50%,transparent)}}}textarea{resize:vertical}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-date-and-time-value{min-height:1lh;text-align:inherit}::-webkit-datetime-edit{display:inline-flex}::-webkit-datetime-edit-fields-wrapper{padding:0}::-webkit-datetime-edit{padding-block:0}::-webkit-datetime-edit-year-field{padding-block:0}::-webkit-datetime-edit-month-field{padding-block:0}::-webkit-datetime-edit-day-field{padding-block:0}::-webkit-datetime-edit-hour-field{padding-block:0}::-webkit-datetime-edit-minute-field{padding-block:0}::-webkit-datetime-edit-second-field{padding-block:0}::-webkit-datetime-edit-millisecond-field{padding-block:0}::-webkit-datetime-edit-meridiem-field{padding-block:0}:-moz-ui-invalid{box-shadow:none}button,input:where([type=button],[type=reset],[type=submit]){appearance:button}::file-selector-button{appearance:button}::-webkit-inner-spin-button{height:auto}::-webkit-outer-spin-button{height:auto}[hidden]:where(:not([hidden=until-found])){display:none!important}}@layer components,utilities; ';

const unlockButtonCss = "/*! tailwindcss v4.1.3 | MIT License | https://tailwindcss.com */@layer theme{:host,:root{--mvx-font-sans:ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",\"Segoe UI Symbol\",\"Noto Color Emoji\";--mvx-font-mono:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,\"Liberation Mono\",\"Courier New\",monospace;--mvx-default-font-family:var(--mvx-font-sans);--mvx-default-mono-font-family:var(--mvx-font-mono)}}@layer base{*,::backdrop,:after,:before{border:0 solid;box-sizing:border-box;margin:0;padding:0}::file-selector-button{appearance:button;background-color:#0000;border:0 solid;border-radius:0;box-sizing:border-box;color:inherit;font:inherit;font-feature-settings:inherit;font-variation-settings:inherit;letter-spacing:inherit;margin:0;margin-inline-end:4px;opacity:1;padding:0}:host,html{-webkit-text-size-adjust:100%;font-family:var(--mvx-default-font-family,ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",\"Segoe UI Symbol\",\"Noto Color Emoji\");font-feature-settings:var(--mvx-default-font-feature-settings,normal);font-variation-settings:var(--mvx-default-font-variation-settings,normal);line-height:1.5;tab-size:4;-webkit-tap-highlight-color:transparent}hr{border-top-width:1px;color:inherit;height:0}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;-webkit-text-decoration:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:var(--mvx-default-mono-font-family,ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,\"Liberation Mono\",\"Courier New\",monospace);font-feature-settings:var(--mvx-default-mono-font-feature-settings,normal);font-size:1em;font-variation-settings:var(--mvx-default-mono-font-variation-settings,normal)}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}table{border-collapse:collapse;border-color:inherit;text-indent:0}:-moz-focusring{outline:auto}progress{vertical-align:baseline}summary{display:list-item}menu,ol,ul{list-style:none}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{height:auto;max-width:100%}button,input,optgroup,select,textarea{background-color:#0000;border-radius:0;color:inherit;font:inherit;font-feature-settings:inherit;font-variation-settings:inherit;letter-spacing:inherit;opacity:1}:where(select:is([multiple],[size])) optgroup{font-weight:bolder}:where(select:is([multiple],[size])) optgroup option{padding-inline-start:20px}::placeholder{opacity:1}@supports (not ((-webkit-appearance:-apple-pay-button))) or (contain-intrinsic-size:1px){::placeholder{color:currentColor}@supports (color:color-mix(in lab,red,red)){::placeholder{color:color-mix(in oklab,currentColor 50%,transparent)}}}textarea{resize:vertical}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-date-and-time-value{min-height:1lh;text-align:inherit}::-webkit-datetime-edit{display:inline-flex;padding-block:0}::-webkit-datetime-edit-fields-wrapper{padding:0}::-webkit-datetime-edit-month-field,::-webkit-datetime-edit-year-field{padding-block:0}::-webkit-datetime-edit-day-field,::-webkit-datetime-edit-hour-field{padding-block:0}::-webkit-datetime-edit-minute-field,::-webkit-datetime-edit-second-field{padding-block:0}::-webkit-datetime-edit-meridiem-field,::-webkit-datetime-edit-millisecond-field{padding-block:0}:-moz-ui-invalid{box-shadow:none}button,input:where([type=button],[type=reset],[type=submit]){appearance:button}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[hidden]:where(:not([hidden=until-found])){display:none!important}}@layer components,utilities; /*! tailwindcss v4.1.3 | MIT License | https://tailwindcss.com */@layer base{}@layer components,utilities; /*! tailwindcss v4.1.3 | MIT License | https://tailwindcss.com */@layer base{}@layer components,utilities; /*! tailwindcss v4.1.3 | MIT License | https://tailwindcss.com */@layer base{}@layer components,utilities; /*! tailwindcss v4.1.3 | MIT License | https://tailwindcss.com */@layer base{}@layer components,utilities; /*! tailwindcss v4.1.3 | MIT License | https://tailwindcss.com */@layer base{}@layer components,utilities; /*! tailwindcss v4.1.3 | MIT License | https://tailwindcss.com */@layer base{}@layer components,utilities; /*! tailwindcss v4.1.3 | MIT License | https://tailwindcss.com */@layer base{}@layer components,utilities; /*! tailwindcss v4.1.3 | MIT License | https://tailwindcss.com */@layer base{}@layer components,utilities; /*! tailwindcss v4.1.3 | MIT License | https://tailwindcss.com */@layer base{}@layer components,utilities;.unlock-button{align-items:center;background:#3535354d;cursor:pointer;display:flex;gap:16px;height:60px;padding:0 16px 0 12px;transition:all .2s}.unlock-button:hover{background:#353535}.unlock-button:first-child{border-top-left-radius:12px;border-top-right-radius:12px}.unlock-button:last-child{border-bottom-left-radius:12px;border-bottom-right-radius:12px}.unlock-button .unlock-button-icon{align-items:flex-end;display:flex;height:40px;justify-content:flex-start;width:40px}.unlock-button .unlock-button-label{color:#e8e8e8;font-size:16px;line-height:1}.unlock-button .unlock-button-status{font-size:12px;font-weight:500;line-height:1;margin-left:auto}.unlock-button .unlock-button-status .unlock-button-status-open{color:#23f7dd;padding:0 8px}.unlock-button .unlock-button-status .unlock-button-status-install{align-items:center;background:#0b0b0bcc;border:1px solid #40404066;border-radius:20px;display:flex;gap:4px;padding:4px 8px}.unlock-button .unlock-button-status .unlock-button-status-install .unlock-button-status-install-label{color:#23f7dd}.unlock-button .unlock-button-status .unlock-button-status-install .unlock-button-status-install-icon{align-items:center;display:flex}.unlock-button .unlock-button-status .unlock-button-status-install .unlock-button-status-install-icon svg path{fill:#23f7dd}";

const UnlockButton = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
    }
    render() {
        const isExtensionProvider = this.type === ProviderTypeEnum.extension;
        const isMetaMaskProvider = this.type === ProviderTypeEnum.metamask;
        const isDetectableProvider = isExtensionProvider || isMetaMaskProvider;
        const isExtensionInstalled = isExtensionProvider && getIsExtensionAvailable();
        const isMetaMaskInstalled = isMetaMaskProvider && getIsMetaMaskAvailable();
        const shouldShowOpenLabel = isDetectableProvider && (isExtensionInstalled || isMetaMaskInstalled);
        return (h("div", { key: '5756eea34ddce724af94282fb2a69d38f31204dd', class: { 'unlock-button': true, [this.class]: Boolean(this.class) } }, this.icon ? (h("div", { class: "unlock-button-icon" }, this.icon)) : (h("div", { class: "unlock-button-icon" }, h("mvx-multiversx-logo-icon", null))), h("div", { key: '123d257164bd25376ad1dc3e67e36f008115b63d', class: "unlock-button-label" }, this.label), isDetectableProvider && (h("div", { key: 'bef6d9d10c0bb7d56efb46f6b739c7f37e8513ff', class: "unlock-button-status" }, shouldShowOpenLabel ? (h("div", { class: "unlock-button-status-open" }, "Open")) : (h("div", { class: "unlock-button-status-install" }, h("span", { class: "unlock-button-status-install-label" }, "Install"), h("mvx-arrow-up-right-icon", { class: "unlock-button-status-install-icon" })))))));
    }
};
UnlockButton.style = unlockButtonCss;

const WalletProviderIcon = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
    }
    render() {
        return (h("svg", { key: "c83b737f20a51bc040a75ed32002d6a9023af36a", xmlns: "http://www.w3.org/2000/svg", height: "40", width: "40", viewBox: "0 0 40 40", fill: "none" }, h("mask", { key: "bf32e0fe7dc1a4d3f52a98796fa03dfd17bc3425", id: "mask0_7913_1658", maskUnits: "userSpaceOnUse", x: "0", y: "0", width: "40", height: "41" }, h("path", { key: "e80337145f016ca05f367e4772f2daf66e3938b1", "fill-rule": "evenodd", "clip-rule": "evenodd", d: "M40 12.7774C40 12.3026 40.0002 11.8277 39.9973 11.3528C39.9949 10.9527 39.9903 10.5528 39.9794 10.1529C39.9559 9.28144 39.9045 8.40246 39.7495 7.54067C39.5923 6.66645 39.3356 5.85281 38.9311 5.0585C38.5335 4.27777 38.014 3.56336 37.3942 2.94399C36.7745 2.32462 36.0599 1.8055 35.2789 1.40807C34.4838 1.00346 33.6693 0.746861 32.7941 0.589726C31.9322 0.434969 31.053 0.383659 30.1815 0.360115C29.7813 0.34929 29.3812 0.344727 28.9809 0.342251C28.5058 0.339339 28.0307 0.339581 27.5555 0.339581L22.0387 0.319824H17.9125L12.4933 0.339581C12.0172 0.339581 11.5411 0.339339 11.0651 0.342251C10.664 0.344727 10.2631 0.34929 9.86221 0.360115C8.98867 0.383659 8.10746 0.435018 7.24354 0.589969C6.36719 0.747056 5.55146 1.00356 4.75526 1.40788C3.97259 1.80535 3.25643 2.32453 2.63547 2.94399C2.0146 3.56331 1.49416 4.27758 1.09577 5.05816C0.69014 5.85286 0.432958 6.66699 0.275386 7.54169C0.120242 8.40314 0.0688344 9.28183 0.0451938 10.1529C0.0344172 10.5528 0.0297571 10.9528 0.0273299 11.3528C0.0244173 11.8277 0 12.4177 0 12.8926L0.00014563 18.2367L0 22.4071L0.02466 27.8648C0.02466 28.3404 0.0244658 28.8159 0.0273299 29.2914C0.0297571 29.692 0.0344172 30.0925 0.0452424 30.4929C0.0688344 31.3655 0.120339 32.2458 0.275629 33.1087C0.433152 33.9841 0.690286 34.7989 1.09557 35.5943C1.49402 36.3761 2.01455 37.0914 2.63547 37.7117C3.25638 38.3319 3.97235 38.8517 4.75487 39.2497C5.55156 39.6549 6.36767 39.9118 7.24456 40.0691C8.1081 40.2241 8.98901 40.2756 9.86221 40.2991C10.2631 40.3099 10.664 40.3145 11.0651 40.317C11.5412 40.3199 12.0172 40.3197 12.4933 40.3197L17.9615 40.3198H22.0979L27.5555 40.3196C28.0307 40.3196 28.5058 40.3199 28.9809 40.317C29.3812 40.3145 29.7813 40.3099 30.1815 40.2991C31.0533 40.2755 31.9328 40.224 32.7951 40.069C33.6698 39.9116 34.4839 39.6548 35.2786 39.2499C36.0597 38.8519 36.7745 38.332 37.3942 37.7117C38.0139 37.0915 38.5333 36.3763 38.931 35.5946C39.3357 34.7989 39.5924 33.9837 39.7497 33.1077C39.9046 32.2451 39.9559 31.3652 39.9795 30.4929C39.9903 30.0924 39.9949 29.6919 39.9973 29.2914C40.0002 28.8159 40 28.3404 40 27.8648C40 27.8648 39.9997 22.5035 39.9997 22.4071V18.2324C39.9997 18.1612 40 12.7774 40 12.7774Z", fill: "white" })), h("g", { key: "66956ddf5bdfa8c103b2bd0cae10117729599c15", mask: "url(#mask0_7913_1658)" }, h("path", { key: "43a484a70726d0ce19adeb9fb15f7529b97d3f38", "fill-rule": "evenodd", "clip-rule": "evenodd", d: "M40 12.7774C40 12.3026 40.0002 11.8277 39.9973 11.3528C39.9949 10.9527 39.9903 10.5528 39.9794 10.1529C39.9559 9.28144 39.9045 8.40246 39.7495 7.54067C39.5923 6.66645 39.3356 5.85281 38.9311 5.0585C38.5335 4.27777 38.014 3.56336 37.3942 2.94399C36.7745 2.32462 36.0599 1.8055 35.2789 1.40807C34.4838 1.00346 33.6693 0.746861 32.7941 0.589726C31.9322 0.434969 31.053 0.383659 30.1815 0.360115C29.7813 0.34929 29.3812 0.344727 28.9809 0.342251C28.5058 0.339339 28.0307 0.339581 27.5555 0.339581L22.0387 0.319824H17.9125L12.4933 0.339581C12.0172 0.339581 11.5411 0.339339 11.0651 0.342251C10.664 0.344727 10.2631 0.34929 9.86221 0.360115C8.98867 0.383659 8.10746 0.435018 7.24354 0.589969C6.36719 0.747056 5.55146 1.00356 4.75526 1.40788C3.97259 1.80535 3.25643 2.32453 2.63547 2.94399C2.0146 3.56331 1.49416 4.27758 1.09577 5.05816C0.69014 5.85286 0.432958 6.66699 0.275386 7.54169C0.120242 8.40314 0.0688344 9.28183 0.0451938 10.1529C0.0344172 10.5528 0.0297571 10.9528 0.0273299 11.3528C0.0244173 11.8277 0 12.4177 0 12.8926L0.00014563 18.2367L0 22.4071L0.02466 27.8648C0.02466 28.3404 0.0244658 28.8159 0.0273299 29.2914C0.0297571 29.692 0.0344172 30.0925 0.0452424 30.4929C0.0688344 31.3655 0.120339 32.2458 0.275629 33.1087C0.433152 33.9841 0.690286 34.7989 1.09557 35.5943C1.49402 36.3761 2.01455 37.0914 2.63547 37.7117C3.25638 38.3319 3.97235 38.8517 4.75487 39.2497C5.55156 39.6549 6.36767 39.9118 7.24456 40.0691C8.1081 40.2241 8.98901 40.2756 9.86221 40.2991C10.2631 40.3099 10.664 40.3145 11.0651 40.317C11.5412 40.3199 12.0172 40.3197 12.4933 40.3197L17.9615 40.3198H22.0979L27.5555 40.3196C28.0307 40.3196 28.5058 40.3199 28.9809 40.317C29.3812 40.3145 29.7813 40.3099 30.1815 40.2991C31.0533 40.2755 31.9328 40.224 32.7951 40.069C33.6698 39.9116 34.4839 39.6548 35.2786 39.2499C36.0597 38.8519 36.7745 38.332 37.3942 37.7117C38.0139 37.0915 38.5333 36.3763 38.931 35.5946C39.3357 34.7989 39.5924 33.9837 39.7497 33.1077C39.9046 32.2451 39.9559 31.3652 39.9795 30.4929C39.9903 30.0924 39.9949 29.6919 39.9973 29.2914C40.0002 28.8159 40 28.3404 40 27.8648C40 27.8648 39.9997 22.5035 39.9997 22.4071V18.2324C39.9997 18.1612 40 12.7774 40 12.7774Z", fill: "#143736" }), h("rect", { key: "55a0ae602e950cc98ebd18a1f0e70009750d95bb", opacity: "0.4", x: "0.169903", y: "6.65477", width: "39.6602", height: "39.6602", rx: "8.76214", fill: "url(#paint0_linear_7913_1658)", stroke: "url(#paint1_linear_7913_1658)", "stroke-width": "0.339806" }), h("rect", { key: "029957862c4c22c1b4c86bc5ad12c8be1c03bda9", x: "0.169903", y: "12.8198", width: "39.6602", height: "39.6602", rx: "8.76214", fill: "url(#paint2_linear_7913_1658)", stroke: "url(#paint3_linear_7913_1658)", "stroke-width": "0.339806" }), h("g", { key: "5c4c0afff9482a3db010be5bca0e835d3817180f", filter: "url(#filter0_dddd_7913_1658)" }, h("path", { key: "2d5fb6905a438bbcebc4c6dc5f6aa5ecd16dc84c", d: "M13.1383 22.5535L18.8349 19.498L17.8771 17.6499L12.6609 19.7681C12.5265 19.8227 12.3776 19.8227 12.2433 19.7681L7.02558 17.6499L6.06787 19.498L11.7645 22.5535L6.06787 25.6076L7.02558 27.4557L12.2419 25.3375C12.3762 25.2829 12.5251 25.2829 12.6594 25.3375L17.8757 27.4557L18.8334 25.6076L13.1368 22.5521L13.1383 22.5535Z", fill: "#000F0E" }))), h("defs", { key: "5d37b03ea77dae6edeaf38854aaa1a994dc78313" }, h("filter", { key: "902ed8aa9456ae3651cb1f234269178c72f915e1", id: "filter0_dddd_7913_1658", x: "-5.00009", y: "8.71786", width: "34.903", height: "31.9416", filterUnits: "userSpaceOnUse", "color-interpolation-filters": "sRGB" }, h("feFlood", { key: "0a886956028037061a9d4a772442ed91063e20ad", "flood-opacity": "0", result: "BackgroundImageFix" }), h("feColorMatrix", { key: "decc38739391859f6db7530dc1dd8ce5a3b5439d", in: "SourceAlpha", type: "matrix", values: "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 127 0", result: "hardAlpha" }), h("feOffset", { key: "fd016e66f57c7da430ef54fcc41e43b6755d2fed", dy: "0.970874" }), h("feGaussianBlur", { key: "a8aafb9dd74588d00cb77c958c405d2acd3a8416", stdDeviation: "1.26214" }), h("feComposite", { key: "079ef7bc6fd2e7672146e0f1c29f0f30487359ba", in2: "hardAlpha", operator: "out" }), h("feColorMatrix", { key: "6930959da349e3b95a9cb14e9e8679e6f907f85c", type: "matrix", values: "0 0 0 0 0.137255 0 0 0 0 0.968627 0 0 0 0 0.866667 0 0 0 0.1 0" }), h("feBlend", { key: "6e97cb9ce4ac10cf8a35a5cef10fc54a8a49ef05", mode: "normal", in2: "BackgroundImageFix", result: "effect1_dropShadow_7913_1658" }), h("feColorMatrix", { key: "8ec0f635eeb8705ea69879c54dd4017a8bfdeb7c", in: "SourceAlpha", type: "matrix", values: "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 127 0", result: "hardAlpha" }), h("feOffset", { key: "5c76dad0c3439a68d2fe69408286cbbea10643d6", dy: "2.13592" }), h("feGaussianBlur", { key: "5c313e9f78b5e3e88b9af50250ce4269c41f643d", stdDeviation: "5.53398" }), h("feComposite", { key: "50ef04ce000bd546308433ee369ebec189feb144", in2: "hardAlpha", operator: "out" }), h("feColorMatrix", { key: "a107a03fe88b773da9a9b6489532431fcf2228a2", type: "matrix", values: "0 0 0 0 0.137255 0 0 0 0 0.968627 0 0 0 0 0.866667 0 0 0 0.3 0" }), h("feBlend", { key: "d09024cbf57ddce38d279f25ba0df757e70b54ac", mode: "normal", in2: "effect1_dropShadow_7913_1658", result: "effect2_dropShadow_7913_1658" }), h("feColorMatrix", { key: "70d067ca1fda6ffa6adb8d364ed997f9e46fd44c", in: "SourceAlpha", type: "matrix", values: "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 127 0", result: "hardAlpha" }), h("feOffset", { key: "30370f6f8f25c33228794e00f006fccd6caf98d8", dy: "0.291262" }), h("feGaussianBlur", { key: "1484fd86eb80598efb5647b2aa867eb62334f2b0", stdDeviation: "0.533981" }), h("feComposite", { key: "f80bc829dae798c0fc15932315f7a32f9bcdad1f", in2: "hardAlpha", operator: "out" }), h("feColorMatrix", { key: "50c5bb6c4ab027ac495fee80c4aeb3a85b26b82d", type: "matrix", values: "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0.35 0" }), h("feBlend", { key: "edca62d29e6e3cbb36cb6f34b0be91ac99419ab5", mode: "normal", in2: "effect2_dropShadow_7913_1658", result: "effect3_dropShadow_7913_1658" }), h("feColorMatrix", { key: "63cd84e9ec560130f8440124ed272ccebc85f12c", in: "SourceAlpha", type: "matrix", values: "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 127 0", result: "hardAlpha" }), h("feOffset", { key: "dd92d0ceaef96d85919d82cd51d529673fbdcef2", dy: "0.194175" }), h("feGaussianBlur", { key: "4adadfcd0e263b470fb0101cd4d7a03da5d5532b", stdDeviation: "0.0970874" }), h("feComposite", { key: "a7d72125838254feafbf03fb2136f6e587327839", in2: "hardAlpha", operator: "out" }), h("feColorMatrix", { key: "ae24bb4c289cd3223187dbd76e5ace582e81c016", type: "matrix", values: "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0.25 0" }), h("feBlend", { key: "e227d05ff81b8b7d009481609951d1bb781cb82b", mode: "normal", in2: "effect3_dropShadow_7913_1658", result: "effect4_dropShadow_7913_1658" }), h("feBlend", { key: "c9d16902646a44e360acfe8e9a117baf64a73987", mode: "normal", in: "SourceGraphic", in2: "effect4_dropShadow_7913_1658", result: "shape" })), h("linearGradient", { key: "0588e136801b63399e137acb52864f770bc98612", id: "paint0_linear_7913_1658", x1: "20.2306", y1: "15.5045", x2: "20.2306", y2: "35.9947", gradientUnits: "userSpaceOnUse" }, h("stop", { key: "5755986602dbe8f082e240489d5113549f4a8cbd", "stop-color": "#00FFE0" }), h("stop", { key: "aa923d59a6872a8755fcbe42e4228152ad3b7e18", offset: "1", "stop-color": "#00FFE0" })), h("linearGradient", { key: "45281372617149433953a240eb801a30ff63ec48", id: "paint1_linear_7913_1658", x1: "6.49826", y1: "27.07", x2: "42.1154", y2: "23.7635", gradientUnits: "userSpaceOnUse" }, h("stop", { key: "5d60540fea1874ec583a9d2be084e4e9718a432d", "stop-color": "#00FFE0" }), h("stop", { key: "5a88f316e5e8fa3d80155408339a3665a941f0e3", offset: "1", "stop-color": "#4CFFE9" })), h("linearGradient", { key: "50318bb0d2d0ce5fb84c8a39359b287c736b646e", id: "paint2_linear_7913_1658", x1: "20.2306", y1: "21.6695", x2: "20.2306", y2: "42.1597", gradientUnits: "userSpaceOnUse" }, h("stop", { key: "81047daa0a392ea2e54c84bcfcd206baa2455beb", "stop-color": "#00FFE0" }), h("stop", { key: "25ab8eba3ea76bbc96527b87b41fbe2c038d6a1c", offset: "1", "stop-color": "#00FFE0" })), h("linearGradient", { key: "7ee2c485860dbd4b91275c34b7885c42a8fd4ceb", id: "paint3_linear_7913_1658", x1: "6.49826", y1: "33.2351", x2: "42.1154", y2: "29.9285", gradientUnits: "userSpaceOnUse" }, h("stop", { key: "274c6afedf60483b88f1898136cf9c12bf914c12", "stop-color": "#00FFE0" }), h("stop", { key: "eef9d1e7d36f22ba6ebf2dc619ee399b4545264b", offset: "1", "stop-color": "#4CFFE9" })))));
    }
};

WalletProviderIcon.style = '/*! tailwindcss v4.1.3 | MIT License | https://tailwindcss.com */@layer theme{:root,:host{--mvx-font-sans:ui-sans-serif,system-ui,sans-serif,"Apple Color Emoji","Segoe UI Emoji","Segoe UI Symbol","Noto Color Emoji";--mvx-font-mono:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,"Liberation Mono","Courier New",monospace;--mvx-default-font-family:var(--mvx-font-sans);--mvx-default-mono-font-family:var(--mvx-font-mono)}}@layer base{*,:after,:before,::backdrop{box-sizing:border-box;border:0 solid;margin:0;padding:0}::file-selector-button{box-sizing:border-box;border:0 solid;margin:0;padding:0}html,:host{-webkit-text-size-adjust:100%;tab-size:4;line-height:1.5;font-family:var(--mvx-default-font-family,ui-sans-serif,system-ui,sans-serif,"Apple Color Emoji","Segoe UI Emoji","Segoe UI Symbol","Noto Color Emoji");font-feature-settings:var(--mvx-default-font-feature-settings,normal);font-variation-settings:var(--mvx-default-font-variation-settings,normal);-webkit-tap-highlight-color:transparent}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;-webkit-text-decoration:inherit;-webkit-text-decoration:inherit;-webkit-text-decoration:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:var(--mvx-default-mono-font-family,ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,"Liberation Mono","Courier New",monospace);font-feature-settings:var(--mvx-default-mono-font-feature-settings,normal);font-variation-settings:var(--mvx-default-mono-font-variation-settings,normal);font-size:1em}small{font-size:80%}sub,sup{vertical-align:baseline;font-size:75%;line-height:0;position:relative}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}:-moz-focusring{outline:auto}progress{vertical-align:baseline}summary{display:list-item}ol,ul,menu{list-style:none}img,svg,video,canvas,audio,iframe,embed,object{vertical-align:middle;display:block}img,video{max-width:100%;height:auto}button,input,select,optgroup,textarea{font:inherit;font-feature-settings:inherit;font-variation-settings:inherit;letter-spacing:inherit;color:inherit;opacity:1;background-color:#0000;border-radius:0}::file-selector-button{font:inherit;font-feature-settings:inherit;font-variation-settings:inherit;letter-spacing:inherit;color:inherit;opacity:1;background-color:#0000;border-radius:0}:where(select:is([multiple],[size])) optgroup{font-weight:bolder}:where(select:is([multiple],[size])) optgroup option{padding-inline-start:20px}::file-selector-button{margin-inline-end:4px}::placeholder{opacity:1}@supports (not ((-webkit-appearance:-apple-pay-button))) or (contain-intrinsic-size:1px){::placeholder{color:currentColor}@supports (color:color-mix(in lab, red, red)){::placeholder{color:color-mix(in oklab,currentColor 50%,transparent)}}}textarea{resize:vertical}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-date-and-time-value{min-height:1lh;text-align:inherit}::-webkit-datetime-edit{display:inline-flex}::-webkit-datetime-edit-fields-wrapper{padding:0}::-webkit-datetime-edit{padding-block:0}::-webkit-datetime-edit-year-field{padding-block:0}::-webkit-datetime-edit-month-field{padding-block:0}::-webkit-datetime-edit-day-field{padding-block:0}::-webkit-datetime-edit-hour-field{padding-block:0}::-webkit-datetime-edit-minute-field{padding-block:0}::-webkit-datetime-edit-second-field{padding-block:0}::-webkit-datetime-edit-millisecond-field{padding-block:0}::-webkit-datetime-edit-meridiem-field{padding-block:0}:-moz-ui-invalid{box-shadow:none}button,input:where([type=button],[type=reset],[type=submit]){appearance:button}::file-selector-button{appearance:button}::-webkit-inner-spin-button{height:auto}::-webkit-outer-spin-button{height:auto}[hidden]:where(:not([hidden=until-found])){display:none!important}}@layer components,utilities; ';

const XAliasProviderIcon = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
    }
    render() {
        return (h("svg", { key: "3924ccc85285faa79894a55a46c3f04ff9f0e3c8", xmlns: "http://www.w3.org/2000/svg", viewBox: "0 0 40 40", width: "40", height: "40", fill: "none" }, h("path", { key: "9f7585b77a0d81b28d2decbe40179f25dac0db17", d: "M0.5 20C0.5 15.2718 0.501062 11.776 0.861658 9.09391C1.22032 6.42621 1.9264 4.63857 3.28249 3.28249C4.63857 1.9264 6.42621 1.22032 9.09391 0.861658C11.776 0.501062 15.2718 0.5 20 0.5C24.7282 0.5 28.224 0.501062 30.9061 0.861658C33.5738 1.22032 35.3614 1.9264 36.7175 3.28249C38.0736 4.63857 38.7797 6.42621 39.1383 9.09391C39.4989 11.776 39.5 15.2718 39.5 20C39.5 24.7282 39.4989 28.224 39.1383 30.9061C38.7797 33.5738 38.0736 35.3614 36.7175 36.7175C35.3614 38.0736 33.5738 38.7797 30.9061 39.1383C28.224 39.4989 24.7282 39.5 20 39.5C15.2718 39.5 11.776 39.4989 9.09391 39.1383C6.42621 38.7797 4.63857 38.0736 3.28249 36.7175C1.9264 35.3614 1.22032 33.5738 0.861658 30.9061C0.501062 28.224 0.5 24.7282 0.5 20Z", fill: "white" }), h("path", { key: "8b6ed2c6d65af667f2b3389264224c06943f931c", d: "M0.5 20C0.5 15.2718 0.501062 11.776 0.861658 9.09391C1.22032 6.42621 1.9264 4.63857 3.28249 3.28249C4.63857 1.9264 6.42621 1.22032 9.09391 0.861658C11.776 0.501062 15.2718 0.5 20 0.5C24.7282 0.5 28.224 0.501062 30.9061 0.861658C33.5738 1.22032 35.3614 1.9264 36.7175 3.28249C38.0736 4.63857 38.7797 6.42621 39.1383 9.09391C39.4989 11.776 39.5 15.2718 39.5 20C39.5 24.7282 39.4989 28.224 39.1383 30.9061C38.7797 33.5738 38.0736 35.3614 36.7175 36.7175C35.3614 38.0736 33.5738 38.7797 30.9061 39.1383C28.224 39.4989 24.7282 39.5 20 39.5C15.2718 39.5 11.776 39.4989 9.09391 39.1383C6.42621 38.7797 4.63857 38.0736 3.28249 36.7175C1.9264 35.3614 1.22032 33.5738 0.861658 30.9061C0.501062 28.224 0.5 24.7282 0.5 20Z", stroke: "#E5E5E5" }), h("path", { key: "94baba49e282b7d6cbb7bcf6f5d62e6d9e61f71c", d: "M30.56 20.25C30.56 19.47 30.49 18.72 30.36 18H20V22.26H25.92C25.66 23.63 24.88 24.79 23.71 25.57V28.34H27.28C29.36 26.42 30.56 23.6 30.56 20.25Z", fill: "#4285F4" }), h("path", { key: "14dc202d0cdf45038ad42c93f396d4408564fdc0", d: "M19.9997 31.0001C22.9697 31.0001 25.4597 30.0201 27.2797 28.3401L23.7097 25.5701C22.7297 26.2301 21.4797 26.6301 19.9997 26.6301C17.1397 26.6301 14.7097 24.7001 13.8397 22.1001H10.1797V24.9401C11.9897 28.5301 15.6997 31.0001 19.9997 31.0001Z", fill: "#34A853" }), h("path", { key: "234334639c21e61f047a8898240d8b9eb3c6f751", d: "M13.84 22.0898C13.62 21.4298 13.49 20.7298 13.49 19.9998C13.49 19.2698 13.62 18.5698 13.84 17.9098V15.0698H10.18C9.43 16.5498 9 18.2198 9 19.9998C9 21.7798 9.43 23.4498 10.18 24.9298L13.03 22.7098L13.84 22.0898Z", fill: "#FBBC05" }), h("path", { key: "0c5627be856935490ba902087433c232b285f21e", d: "M19.9997 13.38C21.6197 13.38 23.0597 13.94 24.2097 15.02L27.3597 11.87C25.4497 10.09 22.9697 9 19.9997 9C15.6997 9 11.9897 11.47 10.1797 15.07L13.8397 17.91C14.7097 15.31 17.1397 13.38 19.9997 13.38Z", fill: "#EA4335" })));
    }
};

XAliasProviderIcon.style = '/*! tailwindcss v4.1.3 | MIT License | https://tailwindcss.com */@layer theme{:root,:host{--mvx-font-sans:ui-sans-serif,system-ui,sans-serif,"Apple Color Emoji","Segoe UI Emoji","Segoe UI Symbol","Noto Color Emoji";--mvx-font-mono:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,"Liberation Mono","Courier New",monospace;--mvx-default-font-family:var(--mvx-font-sans);--mvx-default-mono-font-family:var(--mvx-font-mono)}}@layer base{*,:after,:before,::backdrop{box-sizing:border-box;border:0 solid;margin:0;padding:0}::file-selector-button{box-sizing:border-box;border:0 solid;margin:0;padding:0}html,:host{-webkit-text-size-adjust:100%;tab-size:4;line-height:1.5;font-family:var(--mvx-default-font-family,ui-sans-serif,system-ui,sans-serif,"Apple Color Emoji","Segoe UI Emoji","Segoe UI Symbol","Noto Color Emoji");font-feature-settings:var(--mvx-default-font-feature-settings,normal);font-variation-settings:var(--mvx-default-font-variation-settings,normal);-webkit-tap-highlight-color:transparent}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;-webkit-text-decoration:inherit;-webkit-text-decoration:inherit;-webkit-text-decoration:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:var(--mvx-default-mono-font-family,ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,"Liberation Mono","Courier New",monospace);font-feature-settings:var(--mvx-default-mono-font-feature-settings,normal);font-variation-settings:var(--mvx-default-mono-font-variation-settings,normal);font-size:1em}small{font-size:80%}sub,sup{vertical-align:baseline;font-size:75%;line-height:0;position:relative}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}:-moz-focusring{outline:auto}progress{vertical-align:baseline}summary{display:list-item}ol,ul,menu{list-style:none}img,svg,video,canvas,audio,iframe,embed,object{vertical-align:middle;display:block}img,video{max-width:100%;height:auto}button,input,select,optgroup,textarea{font:inherit;font-feature-settings:inherit;font-variation-settings:inherit;letter-spacing:inherit;color:inherit;opacity:1;background-color:#0000;border-radius:0}::file-selector-button{font:inherit;font-feature-settings:inherit;font-variation-settings:inherit;letter-spacing:inherit;color:inherit;opacity:1;background-color:#0000;border-radius:0}:where(select:is([multiple],[size])) optgroup{font-weight:bolder}:where(select:is([multiple],[size])) optgroup option{padding-inline-start:20px}::file-selector-button{margin-inline-end:4px}::placeholder{opacity:1}@supports (not ((-webkit-appearance:-apple-pay-button))) or (contain-intrinsic-size:1px){::placeholder{color:currentColor}@supports (color:color-mix(in lab, red, red)){::placeholder{color:color-mix(in oklab,currentColor 50%,transparent)}}}textarea{resize:vertical}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-date-and-time-value{min-height:1lh;text-align:inherit}::-webkit-datetime-edit{display:inline-flex}::-webkit-datetime-edit-fields-wrapper{padding:0}::-webkit-datetime-edit{padding-block:0}::-webkit-datetime-edit-year-field{padding-block:0}::-webkit-datetime-edit-month-field{padding-block:0}::-webkit-datetime-edit-day-field{padding-block:0}::-webkit-datetime-edit-hour-field{padding-block:0}::-webkit-datetime-edit-minute-field{padding-block:0}::-webkit-datetime-edit-second-field{padding-block:0}::-webkit-datetime-edit-millisecond-field{padding-block:0}::-webkit-datetime-edit-meridiem-field{padding-block:0}:-moz-ui-invalid{box-shadow:none}button,input:where([type=button],[type=reset],[type=submit]){appearance:button}::file-selector-button{appearance:button}::-webkit-inner-spin-button{height:auto}::-webkit-outer-spin-button{height:auto}[hidden]:where(:not([hidden=until-found])){display:none!important}}@layer components,utilities; ';

export { ArrowUpRightIcon as mvx_arrow_up_right_icon, ExtensionProviderIcon as mvx_extension_provider_icon, LedgerProviderIcon as mvx_ledger_provider_icon, MetaMaskProviderIcon as mvx_metamask_provider_icon, MultiversXLogoIcon as mvx_multiversx_logo_icon, PasskeyProviderIcon as mvx_passkey_provider_icon, UnlockButton as mvx_unlock_button, WalletProviderIcon as mvx_wallet_provider_icon, XAliasProviderIcon as mvx_xalias_provider_icon };
//# sourceMappingURL=mvx-arrow-up-right-icon.mvx-extension-provider-icon.mvx-ledger-provider-icon.mvx-metamask-provider-icon.mvx-multiversx-logo-icon.mvx-passkey-provider-icon.mvx-unlock-button.mvx-wallet-provider-icon.mvx-xalias-provider-icon.entry.js.map

//# sourceMappingURL=mvx-arrow-up-right-icon_9.entry.js.map